turf/var
	rowHeight
	stackedHeight=0
	autoEdges=0
	topDensity=1
	behindWalls=0
	edgeID=0
	isDecor=0
	mergeID=0
	bottomSpikes
	list/alsoMergesInto
	list/onlyEdgesAgainst
var/list/fourSides=list("T"=2,"B"=1,"L"=4,"R"=8)
var/list/topDensityList=list("TL","T","TR","TLR")
var/list/cornerFillers=list("TBLR"=list("TLC"=NORTHWEST,"TRC"=NORTHEAST,"BLC"=SOUTHWEST,"BRC"=SOUTHEAST),\
	"TLR"=list("BLC"=SOUTHWEST,"BRC"=SOUTHEAST),\
	"BLR"=list("TLC"=NORTHWEST,"TRC"=NORTHEAST),\
	"TBL"=list("TRC"=NORTHEAST,"BRC"=SOUTHEAST),\
	"TBR"=list("TLC"=NORTHWEST,"BLC"=SOUTHWEST),\
	"BL"=list("TRC"=NORTHEAST),\
	"BR"=list("TLC"=NORTHWEST),\
	"TR"=list("BLC"=SOUTHWEST),\
	"TL"=list("BRC"=SOUTHEAST))
turf/proc/AutoEdges()
	if(src.isDecor)	return
	src.icon_state=""
	if(src.overlays)	src.overlays=null
	if(!src.topDensity)	src.density=initial(src.density)
	for(var/v in fourSides)
		var/turf/T=get_step(src,fourSides[v])
		if(!T)	continue
		if(src.CanMergeWith(T))
			src.icon_state+=v
			if(v=="T" && src.icon_state && src.bottomSpikes && (T.icon_state=="B" || T.icon_state=="TB"))	{src.icon_state="TB";break}
	if(src.icon_state in cornerFillers)
		var/list/theseCorners=cornerFillers[src.icon_state]
		for(var/v in theseCorners)
			var/turf/T=get_step(src,theseCorners[v])
			if(!T)	continue
			if(src.CanMergeWith(T))	continue
			global.autoEdgeCorner.icon=src.icon
			global.autoEdgeCorner.icon_state=v
			src.overlays+=global.autoEdgeCorner
	if(src.stackedHeight)
		src.FindStackedHeight()
		spawn(src.rowHeight)
			var/turf/T=get_step(src,SOUTH)
			if(T && src.type==T.type && src.rowHeight<=src.stackedHeight)
				var/baseState=T.icon_state
				if(T.rowHeight)	baseState=copytext(baseState,1,length(baseState))
				src.icon_state="[baseState][src.rowHeight]"
	if(!src.topDensity)
		if(src.icon_state in topDensityList)	src.density=0
		src.UpdateTurfLayer()
		src.layer+=32

turf/proc/FindStackedHeight()
	src.rowHeight=null
	var/turf/T=get_step(src,SOUTH)
	while(T && T.type==src.type)
		T=get_step(T,SOUTH)
		src.rowHeight+=1

var/obj/Supplemental/AutoEdgeCorner/autoEdgeCorner=new
obj/Supplemental/AutoEdgeCorner
	layer=FLOAT_LAYER

turf/UnderlayDummy
	density=1
	icon_state="TBLR"
	icon='AutoTurfs.dmi'
	icon_state="Castle01Moat"

var/list/groundDirs=list(SOUTHWEST,SOUTH,SOUTHEAST)
turf/proc/CanMergeWith(var/turf/T)
	if(!T)	return 1
	if(T.type==src.type && T.mergeID==src.mergeID && T.edgeID>=src.edgeID)	return 1
	if(src.onlyEdgesAgainst)
		var/allowMerge=1
		for(var/v in src.onlyEdgesAgainst)
			if(istype(T,text2path(v)))	allowMerge=0
		return allowMerge
	else
		if(src.behindWalls && !T.topDensity && (get_dir(src,T) in groundDirs))	return 1
		for(var/v in src.alsoMergesInto)
			if(istype(T,text2path(v)))	return 1

turf/AutoEdges
	autoEdges=1
	icon_state="BL"
	New(var/newLoc,var/newEdges=1)
		if(src.autoEdges && newEdges)	src.AutoEdges()
		return ..()
	PortWall
		density=1
		icon='PortWall.dmi'
	PortWall2
		density=1
		icon='PortWall2.dmi'
	PortWallTop
		density=1
		topDensity=0
		icon='PortWallTop.dmi'
	TileFloor
		density=0
		icon='TileFloor.dmi'
	GrassUndulation
		icon_state="Patch"
		icon='Undulation.dmi'
	GrassUndulation1
		density=1
		icon_state="Corners"
		icon='Undulation1.dmi'
		onlyEdgesAgainst=list("/turf/Grass","/turf/AutoEdges/CaveFloorTop","/turf/AutoEdges/CaveWallInt")
	Dock
		icon='Dock.dmi'
	Ocean01
		density=1
		icon='Ocean01.dmi'
		alsoMergesInto=list("/turf/Beaches/Ocean01/Water","/turf/AutoEdges/Dock")
	FancyTiles
		onlyEdgesAgainst=list("/turf/Grass")
		icon='FancyTiles.dmi'
	Castle01Tiles
		icon_state="BL"
		icon='Castle01Tiles.dmi'
		alsoMergesInto=list("/turf/Castle01/Wall")
	Castle01Roof
		density=1
		stackedHeight=1
		topDensity=0
		icon='Castle01Roof.dmi'
	Flowers
		icon_state="BL"
		icon='Flowers.dmi'
	Castle01_Moat
		density=1
		behindWalls=1
		icon='Castle01Moat.dmi'
	Road01
		icon='Road01.dmi'
		icon_state="Patch"
	Road01_Inline
		icon='Road01.dmi'
		icon_state="Patch"
		alsoMergesInto=list("/turf/Grass","/turf/Castle01/MossyWall","/turf/AutoEdges/Flowers")
	Roof02
		density=1
		topDensity=0
		icon='Roof02.dmi'
		icon_state="Patch"
	Wall01
		density=1
		topDensity=0
		icon='Wall01.dmi'
		icon_state="Patch"
		alsoMergesInto=list("/turf/Supplemental/Black")
	Wall02
		density=1
		topDensity=0
		icon='Wall02.dmi'
		icon_state="Patch"
		alsoMergesInto=list("/turf/Supplemental/Black")
	Wall03
		density=1
		topDensity=0
		icon='Wall03.dmi'
		icon_state="Patch"
		alsoMergesInto=list("/turf/Supplemental/Black")
	Carpet01
		icon='Carpet01.dmi'
		behindWalls=1