mob/Pets/var/tmp/datum/BattleOrderDatum/battleOrderDatum
datum/BattleOrderDatum
	var/list/turnList=list()

mob/proc/SetupBattle()
	src.inBattle=1
	src.battleID+=1
	src.stepsUntilBattle=rand(20,30)
	if(src.client)
		src.ChangeMusic('Battle1.mid')
		src.client.screen+=globalBattleOutline
		src.client.screen+=battleBGs[src.battleBG]
		src.client.screen+=battleBGs["BattleTextBG"]

var/obj/Overlays/InBattleIcon/inBattleIcon=new
obj/Overlays/InBattleIcon
	layer=FLOAT_LAYER
	pixel_y=40
	icon='Decorations.dmi'
	icon_state="WeaponIcon"

mob/var/tmp/battleID
mob/var/tmp/inBattle
mob/Pets/var/tmp/mob/Pets/petOpponent
mob/proc/StartBattleAgainst(var/mob/Pets/thisOpponent)
	if(src.client && !src.inBattle)
		src.SetupBattle()
		if(thisOpponent.ownerMob)	thisOpponent.ownerMob.SetupBattle()
		var/datum/BattleOrderDatum/D=new()
		D.turnList=list(src.activePet,thisOpponent)
		for(var/mob/Pets/P in D.turnList)	P.battleOrderDatum=D
		src.activePet.petOpponent=thisOpponent
		thisOpponent.petOpponent=src.activePet
		var/list/petsInvolved=list()
		petsInvolved+=src.petsHeld
		if(thisOpponent.ownerMob)	petsInvolved+=thisOpponent.ownerMob.petsHeld
		else	petsInvolved+=thisOpponent
		for(var/mob/Pets/P in petsInvolved)
			for(var/stat in P.statStages)	P.statStages[stat]=0
		var/list/ownerMobs=list(src,thisOpponent.ownerMob)
		for(var/mob/M in ownerMobs)
			M.overlays-=inBattleIcon
			M.overlays+=inBattleIcon
			spawn(-1)	M.FadeEffect("BattleFade",0)
		thisOpponent.EnterBattle()
		if(!thisOpponent.ownerMob)
			ShowBattleMsg(thisOpponent,"[thisOpponent.WildName()] appeared!")
			ShowBattleMsg(thisOpponent,"Go [src.activePet.WildName()]!")
		else
			ShowBattleMsg(thisOpponent,"[thisOpponent.ownerMob] summons\n[thisOpponent.WildName()]!")
			ShowBattleMsg(thisOpponent,"[src] summons\n[src.activePet.WildName()]!")
		src.activePet.EnterBattle()
		src.HPBGs()
		if(thisOpponent.ownerMob && thisOpponent.ownerMob.client)	thisOpponent.ownerMob.HPBGs()
		var/mob/Pets/nextTurnMob=D.turnList[1]
		nextTurnMob.StartTurn()

mob/Pets/proc/Victory(var/victoryBy="Faint")
	src.petOpponent.ClearPetBattle()
	if(victoryBy!="Capture" && src.petOpponent.ownerMob)
		var/mob/defeatedOwner=src.petOpponent.ownerMob
		defeatedOwner.ExitCave()
		defeatedOwner.RestorePets()
		defeatedOwner.PixelLocate(locate(100,100,1))
		spawn(-1)	ShowMsg(defeatedOwner,"Your monster team was defeated!\nYour monsters have been restored to full health.")
	if(src.ownerMob)
		var/mob/winningOwner=src.ownerMob
		winningOwner.ChangeMusic('009-Fanfare03.mid',0)
		if(victoryBy=="Faint")
			PetDefeated(winningOwner,src.petOpponent)
			var/goldFound=round(src.petOpponent.expYields[1]/10)
			if(src.ownerMob)	src.ownerMob.AddGold(goldFound)
			ShowMsg(src.ownerMob,"Received\n[goldFound] Gold!",2,5,16,7)
	src.ClearPetBattle()

mob/Pets/proc/Fainted()
	spawn(-1)
		var/mob/M=src.petOpponent.ownerMob
		src.battleFront.ScreenMove(SOUTH,3)
		if(M && M.client)	M.client.screen-=src.battleFront
	spawn(-1)
		var/mob/M=src.ownerMob
		src.battleBack.ScreenMove(SOUTH,3)
		if(M && M.client)	M.client.screen-=src.battleBack
	ShowBattleMsg(src,"[src.WildName()]\nwas defeated!")
	if(src.ownerMob)
		var/mob/Pets/swapPet=src.ownerMob.ChooseBattlePet()
		if(istype(swapPet,/mob/Pets))	{src.SwapOutOfBattleFor(swapPet);return swapPet}
	src.petOpponent.Victory("Faint")

mob/Pets/proc/SwapOutOfBattleFor(var/mob/Pets/swapPet)
	if(src.HP>0)
		ShowBattleMsg(src,"[src]\ncome back!")
		src.ExitBattle()
	var/mob/Player/petOwner=src.ownerMob
	swapPet.battleOrderDatum=src.battleOrderDatum
	src.battleOrderDatum.turnList-=src
	src.battleOrderDatum.turnList+=swapPet
	src.battleOrderDatum=null
	swapPet.petOpponent=src.petOpponent
	src.petOpponent.petOpponent=swapPet
	src.petOpponent=null
	petOwner.SetActivePet()
	petOwner.activePet=swapPet
	ShowBattleMsg(src,"Go [swapPet]!")
	swapPet.EnterBattle()
	petOwner.HPBGs()
	if(swapPet.petOpponent.ownerMob)
		swapPet.petOpponent.ownerMob.HPBGs()

mob/var/tmp/lastMoveSelected
mob/Pets/proc/StartTurn()
	src.StEfTurnDuration()
	src.StEfDamage()
	if(src.HP<=0)
		var/mob/Pets/newPet=src.Fainted()
		if(newPet)	src=newPet
		else	return
	if(src.StEfTurnLoss())	goto SkipTurn
	StartAI
	var/mob/petOwner=src.ownerMob
	if(!petOwner)
		var/obj/Moves/thisMove
		if(src.moveObjs.len)	thisMove=pick(src.moveObjs)
		else	thisMove=new/obj/Moves/Tackle
		thisMove.UseMove(src)
	else
		var/lastMenuOpen
		petOwner.PlayMenuSound('Select.ogg')
		MainBattleMenu
		if(!petOwner)	goto StartAI
		petOwner.CustBG(9,5,16,7,"BattleBG")
		petOwner.WriteHUDText(2,16,7,-16,"WhatWill1","What will")
		petOwner.UpdateHUDText("WhatWill1","What will")
		petOwner.WriteHUDText(2,16,6,-10,"WhatWill2","XOXOXOXOXO do?")
		petOwner.UpdateHUDText("WhatWill2","[src.WildName()] do?")
		var/list/whatWillText=list("WhatWill1","WhatWill2")
		var/menuChoice=petOwner.CreateHUDChoices(list("Fight!","Items","Monsters","Run"),"10:-8,7:-17",2,2,4,1,defaultChoice=lastMenuOpen)
		lastMenuOpen=menuChoice
		switch(menuChoice)
			if("Fight!")
				petOwner.ClearBG("BattleBG")
				petOwner.CustBG(12,5,16,7,"PPBG")
				petOwner.CustBG(2,3,11,7,"PPBG")
				for(var/v in whatWillText)	petOwner.UpdateHUDText(v,null)
				var/hudChoice=petOwner.CreateHUDChoices(src.moveObjs,"2,7:-8",1,4,1,1,defaultChoice=petOwner.lastMoveSelected)
				if(petOwner)
					petOwner.ClearPPText()
					if(istype(hudChoice,/obj/Moves))
						var/obj/Moves/thisMove=hudChoice
						petOwner.lastMoveSelected=thisMove
						thisMove.UseMove(src)
					else	goto MainBattleMenu
			if("Items")
				petOwner.ClearBG("BattleBG")
				petOwner.ClearHUDText(whatWillText)
				var/obj/Items/itemChosen=petOwner.GetInventoryItem()
				if(istype(itemChosen,/obj/Items/CancelObj))	itemChosen=null
				if(istype(itemChosen,/obj/Items))	itemChosen.Use(petOwner)
				else	goto MainBattleMenu
			if("Monsters")
				petOwner.ClearBG("BattleBG")
				petOwner.ClearHUDText(whatWillText)
				AvailablePetChoice
				var/mob/Pets/swapPet=petOwner.ChooseBattlePet()
				if(istype(swapPet,/mob/Pets))
					if(petOwner.activePet==swapPet)
						ShowMsg(petOwner,"[swapPet] is already on the field.",2,5,16,7)
						goto AvailablePetChoice
					else
						src.SwapOutOfBattleFor(swapPet)
						src=swapPet
				else	goto MainBattleMenu
			if("Run")
				petOwner<<sound('Run.ogg')
				petOwner.ClearHUDText(whatWillText)
				ShowBattleMsg(src,"Got away safely!")
				src.petOpponent.ClearPetBattle()
				src.ClearPetBattle()
				return
			else	goto MainBattleMenu
	SkipTurn
	if(!src.petOpponent)	return
	if(src.petOpponent.HP<=0)
		var/mob/Pets/newPet=src.petOpponent.Fainted()
		if(!newPet)	return
	src.battleOrderDatum.turnList-=src
	src.battleOrderDatum.turnList+=src
	var/mob/Pets/nextTurnMob=src.battleOrderDatum.turnList[1]
	nextTurnMob.StartTurn()

mob/proc/ClearHUDText(var/list/text2Clear)
	for(var/v in text2Clear)	src.UpdateHUDText(v,null)

mob/Pets/proc/ClearPetBattle()
	if(src.ownerMob)	src.ownerMob.ClearBattle()
	else
		src.battleOrderDatum=null
		src.petOpponent=null

mob/proc/ClearBattle()
	src.overlays-=inBattleIcon
	src.ChangeMusic(src.zoneMusic)
	src.client.screen-=globalBattleOutline
	src.client.screen-=battleBGs[src.battleBG]
	src.client.screen-=battleBGs["BattleTextBG"]
	src.client.screen-=src.activePet.battleBack
	for(var/obj/HUD/Battle/B in src.client.screen)	src.client.screen-=B
	if(src.activePet.petOpponent)	src.client.screen-=src.activePet.petOpponent.battleFront
	src.ClearHUDText(list("FoeName","FoeLevel","PlayerName","PlayerLevel","WhatWill1","WhatWill2","foeHP","playerHP"))
	src.activePet.battleOrderDatum=null
	src.activePet.petOpponent=null
	src.ClearBG("BattleBG")
	src.SetActivePet()
	src.inBattle=0