var/caveZ
var/list/cavesInUse

proc/GenerateCave(var/mob/M,var/caveType)
	//var/startTime=world.timeofday
	if(!cavesInUse)
		cavesInUse=list()
		for(var/i=baseZs+1; i<=world.maxz; i++)
			cavesInUse+="[i]"
			cavesInUse["[i]"]=list()
	for(var/v in cavesInUse)
		var/list/caveUsers=cavesInUse[v]
		if(!caveUsers.len)
			caveUsers+=M
			caveZ=text2num(v)
			break
	var/zBlock=block(locate(1,1,caveZ),locate(world.maxx,world.maxy,caveZ))
	for(var/turf/T in zBlock)
		T.contents=null
		new/turf(T)
	var/list/edgeTurfs=list()
	var/list/floorTurfs=list()
	for(var/i=1; i<=2; i++)	floorTurfs+=CaveHallway(i,EAST,caveType)
	for(var/i=1; i<=2; i++)	floorTurfs+=CaveHallway(i,NORTH,caveType)
	var/floorType=text2path("/turf/Caves/CaveFloors/[caveType]01")
	var/underTurfType=text2path("/obj/Supplemental/CaveUnderTurf/[caveType]01")
	var/intWallType=text2path("/turf/AutoEdges/[caveType]WallInt")
	var/wallTopType=text2path("/turf/AutoEdges/[caveType]WallTop")
	var/fillerType=text2path("/turf/Supplemental/CaveFillers/[caveType]01")
	for(var/turf/T in zBlock)	if(T.type==/turf && istype(get_step(T,SOUTH),floorType))
		var/turf/upTile=T	//Fills any holes caused by crossing paths
		for(var/i=1; i<=4; i++)
			upTile=get_step(upTile,NORTH)
			if(!upTile)	break
			if(upTile.type!=/turf)
				floorTurfs+=new floorType(T)
				break
	var/obj/Supplemental/CaveUnderTurf/caveUnderTurf=new underTurfType
	for(var/turf/Caves/CaveFloors/T in floorTurfs)
		var/turf/E=get_step(T,NORTH)
		if(E.type==/turf)	//Puts walls above the path
			var/turf/wallTile=T
			for(var/i=1; i<=2; i++)
				wallTile=get_step(wallTile,NORTH)
				var/turf/AutoEdges/newWall=new intWallType(wallTile,0)
				newWall.underlays+=caveUnderTurf
				edgeTurfs+=newWall
	for(var/turf/T in zBlock)	//Outlines the path with wall toppers
		if(istype(T,floorType) || istype(T,intWallType))
			for(var/turf/E in oview(1,T))	if(E.type==/turf)
				var/turf/AutoEdges/C=new wallTopType(E,0)
				C.underlays+=caveUnderTurf
				edgeTurfs+=C
	for(var/turf/T in zBlock-floorTurfs)	if(T.type==/turf)	new fillerType(T)	//Fills the rest of the space to match BG color
	var/list/doorLocs=list()
	for(var/turf/AutoEdges/E in edgeTurfs)
		E.AutoEdges()	//Refreshes auto edges to make sure they match
		if(prob(50) && E.icon_state=="BLR" && istype(E,intWallType))	CaveObject(get_step(E,SOUTH))
		if(prob(25) &&  E.icon_state=="TLR" && istype(E,wallTopType))	CaveObject(E,rand(8,16))
		if(istype(E,intWallType))	if(E.icon_state=="BLR")	doorLocs+=E
	var/turf/caveEntrance=pick(doorLocs)
	var/turf/caveExit
	var/maxDist=0
	for(var/turf/T in doorLocs)	if(get_dist(caveEntrance,T)>maxDist)
		maxDist=get_dist(caveEntrance,T)
		caveExit=T
	CaveDoor(caveEntrance)
	CaveDoor(caveExit)
	for(var/turf/T in list(caveEntrance,caveExit))
		var/obj/Doorway/D=new(T)
		D.newDir=SOUTH
		D.newMusicID=1
		if(T==caveEntrance)
			D.newX=M.caveObj.x
			D.newY=M.caveObj.y-1
			D.newZ=M.caveObj.z
		else
			var/obj/CaveEntrance/exitLoc=locate(M.caveObj.tagTo)
			D.newX=exitLoc.x
			D.newY=exitLoc.y-1
			D.newZ=exitLoc.z
	//world<<"Gen Time: [world.timeofday-startTime]"
	return caveEntrance

//quick noob code for rain
obj/Door
	var/tagTo
	Cross(var/mob/M)
		if(ismob(M) && M.client)
			var/obj/Door/otherDoor=locate(src.tagTo)
			M.loc=otherDoor.loc

proc/CaveDoor(var/turf/caveEntrance)
	var/turf/doorTop=get_step(caveEntrance,NORTH)
	caveEntrance.icon_state="DoorB"
	doorTop.icon_state="DoorT"
	var/turf/lightT=get_step(caveEntrance,SOUTH)
	var/turf/lightB=get_step(lightT,SOUTH)
	if(istype(lightT,/turf/Caves/CaveFloors))	lightT.icon_state="LightT"
	if(istype(lightB,/turf/Caves/CaveFloors))	lightB.icon_state="LightB"
	for(var/obj/O in lightT.contents+lightB.contents)	O.loc=null

proc/CaveObject(var/turf/T,var/y_offset=0)
	var/obj/Items/RandomDecor/Cave/O=new(T)
	O.step_y+=y_offset
	return O

proc/CaveHallway(var/i,var/caveDir=EAST,caveType)
	var/curHeight=9
	var/list/floorTurfs=list()
	var/startFat=world.maxy-round(world.maxy/6)*(i+1)
	var/floorType="/turf/Caves/CaveFloors/[caveType]01"
	for(var/caveLen=50; caveLen<world.maxx-50; caveLen++)
		if(prob(50))	startFat+=rand(-2,2)	//Changes the curve of the path
		if(prob(50))	//Changes the size of the path
			curHeight+=rand(-2,2)
			curHeight=max(4,curHeight)
			curHeight=min(10,curHeight)
		for(var/curFat=1; curFat<=curHeight-2; curFat++)	//Basic path floor and random objects
			var/turf/thisTile
			if(caveDir==EAST)	thisTile=locate(caveLen,startFat+curFat,caveZ)
			else	thisTile=locate(startFat+curFat,caveLen,caveZ)
			if(thisTile.type!=/turf)	continue
			floorTurfs+=new floorType(thisTile)
	return floorTurfs