var/list/critDomains=list(6.25,12.5,25,33.3,50)
mob/Pets/proc/DamagePet(var/mob/Pets/thisTarget,var/obj/Moves/thisMove)
	var/damage=(src.level*2/5)+2
	var/attackValue=src.attack
	var/defenseValue=thisTarget.defense
	var/attackType="attack"
	var/defenseType="defense"
	if(thisMove.category!="Physical")
		attackType="specialAttack"
		defenseType="specialDefense"
		attackValue=src.specialAttack
		defenseValue=thisTarget.specialDefense
	attackValue=src.GetStagedStat(attackType)
	defenseValue=thisTarget.GetStagedStat(defenseType)
	damage=(damage*thisMove.power*attackValue/50/defenseValue)+2
	damage=damage*(100-rand(0,15))/100
	var/critMsg=""
	var/critDamage=1;	if(rand(1,100)*10<=critDomains[1]*10)
		critDamage=2	//if(src.HasAbility("Sniper"))	cirtDamage=3
		critMsg="A Critical Hit!"
	damage=damage*critDamage
	damage=round(damage)
	if(damage<=0)	damage=1
	if(thisMove.elementType in list(src.elementType1,src.elementType2))	damage=round(damage*1.5)
	var/effectiveMsg=""
	if((thisTarget.elementType1 in weakAgainst[thisMove.elementType]) || (thisTarget.elementType2 in weakAgainst[thisMove.elementType]))
		damage=round(damage*0.5);effectiveMsg="It's not very effective..."
	else	if((thisTarget.elementType1 in strongAgainst[thisMove.elementType]) || (thisTarget.elementType2 in strongAgainst[thisMove.elementType]))
		damage=round(damage*2);effectiveMsg="It's super effective!"
	else	if((thisMove.elementType in immuneTo[thisTarget.elementType1]) || (thisMove.elementType in immuneTo[thisTarget.elementType2]))
		damage=0;effectiveMsg="It has no effect!"
	thisTarget.TakeDamage(damage,null,list(critMsg,effectiveMsg))
	return damage

mob/Pets/proc/GetStagedStat(var/stat)
	var/baseStat=src.vars[stat]
	var/stageMultiplier=(2+src.statStages[stat])/2
	if(src.statStages[stat]<0)	stageMultiplier=2/(2-src.statStages[stat])
	return baseStat*stageMultiplier

mob/Pets/proc/UpdateHPBars(var/instaSet=0)
	var/list/ownerMobs=list(src.ownerMob)
	if(src.petOpponent)	ownerMobs+=src.petOpponent.ownerMob
	for(var/mob/M in ownerMobs)
		if(!M.inBattle)	continue
		if(src.ownerMob==M)	M.UpdateHPBar("playerHP",src,instaSet)
		else	M.UpdateHPBar("foeHP",src,instaSet)

mob/Pets/proc/AddHP(var/amt)
	src.HP+=amt
	if(src.HP>=src.maxHP)	src.HP=src.maxHP
	src.UpdateHPBars(1)

mob/Pets/proc/TakeDamage(var/damage,var/list/preMsgs,var/list/postMsgs)
	for(var/v in preMsgs)	if(v)	ShowBattleMsg(src,v)
	src.HP-=damage
	if(src.HP<0)	src.HP=0
	src.UpdateHPBars()
	for(var/v in postMsgs)	if(v)	ShowBattleMsg(src,v)

var/list/weakAgainst=list("Normal"=list("Rock","Steel"),\
	"Fire"=list("Fire","Water","Rock","Dragon"),\
	"Water"=list("Water","Grass","Dragon"),\
	"Electric"=list("Electric","Grass","Dragon"),\
	"Grass"=list("Fire","Grass","Poison","Flying","Bug","Dragon","Steel"),\
	"Ice"=list("Fire","Ice","Steel"),\
	"Fighting"=list("Poison","Flying","Psychic","Bug"),\
	"Poison"=list("Poison","Ground","Rock","Ghost"),\
	"Ground"=list("Grass","Bug"),\
	"Flying"=list("Electric","Rock","Steel"),\
	"Psychic"=list("Psychic","Steel"),\
	"Bug"=list("Fire","Fighting","Poison","Flying","Ghost","Steel"),\
	"Rock"=list("Fighting","Ground","Steel"),\
	"Ghost"=list("Dark","Steel"),\
	"Dragon"=list(),\
	"Dark"=list("Fighting","Dark","Steel"),\
	"Steel"=list("Fire","Water","Electric","Steel"))
var/list/strongAgainst=list("Normal"=list(),\
	"Fire"=list("Grass","Ice","Bug","Steel"),\
	"Water"=list("Fire","Ground","Rock"),\
	"Electric"=list("Water","Flying"),\
	"Grass"=list("Water","Ground","Rock"),\
	"Ice"=list("Grass","Ground","Flying","Dragon"),\
	"Fighting"=list("Normal","Ice","Rock","Dark","Steel"),\
	"Poison"=list("Grass"),\
	"Ground"=list("Fire","Electric","Poison","Rock","Steel"),\
	"Flying"=list("Grass","Fighting","Bug"),\
	"Psychic"=list("Fighting"),\
	"Bug"=list("Grass","Psychic","Dark"),\
	"Rock"=list("Fire","Ice","Flying","Bug"),\
	"Ghost"=list("Psychic","Ghost"),\
	"Dragon"=list("Dragon"),\
	"Dark"=list("Psychic","Ghost"),\
	"Steel"=list("Ice","Rock"))
var/list/immuneTo=list("Ghost"=list("Normal"),\
	"Ground"=list("Electric"),\
	"Ghost"=list("Fighting"),\
	"Steel"=list("Poison"),\
	"Flying"=list("Ground"),\
	"Dark"=list("Psychic"),\
	"Normal"=list("Ghost"))