mob/Pets/proc
	CalculateStats()
		src.maxHP=round((((src.IVs["HP"]+(2*initial(src.maxHP))+(src.EVs["HP"]/4)+100)*src.level)/100)+10)
		if(src.HP>src.maxHP)	src.HP=src.maxHP
		for(var/v in src.IVs-"HP")	src.vars[v]=round(((((src.IVs[v]+(2*initial(src.vars[v]))+(src.EVs[v]/4))*src.level)/100)+5)*1)
	LevelCheck()
		if(src.level>=100)	return
		if(src.exp>=src.expRequired)
			src.level+=1
			src.exp-=src.expRequired
			src.CalculateExp()
			src.CalculateStats()
			src.HP=src.maxHP
			if(src.ownerMob)
				src.ownerMob.GiveMedal("Ding")
				src.ownerMob.ChangeMusic('001-Victory01.mid',0)
				if(src.level==10)	src.ownerMob.GiveMedal("Level 10")
				if(src.level==25)	src.ownerMob.GiveMedal("Level 25")
				if(src.level==50)	src.ownerMob.GiveMedal("Level 50")
				if(src.level==75)	src.ownerMob.GiveMedal("Level 75")
				if(src.level==100)	src.ownerMob.GiveMedal("Level 100")
			ShowMsg(src.ownerMob,"[src] grew to\nLevel [src.level]!",2,5,16,7)
			if(src.ownerMob)
				if(src.ownerMob.inBattle)	src.ownerMob.UpdateExpBar("playerEXP",src)
				var/curEvoPos=src.evolutionList.Find(initial(src.name))
				for(var/i=curEvoPos+1; i<=src.evolutionList.len; i++)
					var/nextEvo=src.evolutionList[i]
					var/evoLevel=src.evolutionList[nextEvo]
					if(evoLevel && src.level>=evoLevel)
						if(QuickBattleChoice(src.ownerMob,list("Transform!","Not now..."),"[src] is Transforming\ninto [uppertext(nextEvo)]!")=="Transform!")
							var/newPath="[src.parent_type]/[nextEvo]"
							var/mob/Pets/newPet=new newPath(1)
							var/mob/thisOwner=src.ownerMob
							thisOwner.GiveMedal("Darwinism")
							thisOwner.petsHeld+=newPet
							thisOwner.petsHeld.Swap(thisOwner.petsHeld.Find(src),thisOwner.petsHeld.Find(newPet))
							thisOwner.petsHeld-=src
							newPet.isWild=0
							newPet.level=src.level
							for(var/v in src.EVs)	newPet.EVs[v]=src.EVs[v]
							for(var/v in src.IVs)	newPet.IVs[v]=src.IVs[v]
							newPet.CalculateExp()
							newPet.CalculateStats()
							newPet.owner=thisOwner.key
							newPet.ownerMob=thisOwner
							newPet.moveObjs=list()
							newPet.moveObjs+=src.moveObjs
							if(src.name!=initial(src.name))	newPet.name=src.name
							return
					break
				for(var/v in src.levelMoves)
					var/moveName=Split(v,"@")[1]
					var/moveLevel=text2num(Split(v,"@")[2])
					if(moveLevel>src.level)	break
					if(moveLevel==src.level)
						if(src.moveObjs.len>4)	src.moveObjs.Cut(5)
						for(var/obj/Moves/M in src.moveObjs)	if(moveName==M.name)	goto AlreadyLearned
						var/moveType="/obj/Moves/[moveName]"
						while(findtext(moveType," "))	moveType=FindAndReplace(moveType," ","_")
						if(!(text2path(moveType) in typesof(/obj/Moves)))	continue
						ShowMsg(src.ownerMob,"[src] learned\n[moveName]!",2,5,16,7)
						src.moveObjs+=new moveType
						if(src.moveObjs.len>4)
							src.ownerMob.CustBG(2,1,16,4,"ForgetMoves")
							var/thisChoice=src.ownerMob.CreateHUDChoices(src.moveObjs,"2,4:-8",2,3,5,1,"[src] can only know 4 moves.\nChoose a move to forget...",src.moveObjs[src.moveObjs.len])
							if(!thisChoice)	thisChoice=src.moveObjs[5]
							src.moveObjs-=thisChoice
							if(src.ownerMob)
								src.ownerMob.ClearBG("ForgetMoves")
								src.ownerMob.ClearPPText()
					AlreadyLearned
			src.LevelCheck()
	AddExp(var/amt2Give)
		if(src.level>=100)	return
		if(amt2Give>0)
			if(src.GetCaptureInfo("Caught With")=="Exp Stone")	amt2Give=round(amt2Give*1.1)
			src.exp+=amt2Give
			if(src.ownerMob && src.ownerMob.activePet==src)
				spawn(-1)	src.ownerMob.UpdateExpBar("playerEXP",src)
			src.LevelCheck()
	CalculateExp()
		//Erratic Formulas
		if(src.expFormula=="Erratic")
			if("1-50")	src.expRequired=(PowerOf(level,3)*(100-level))/50
			if("50-68")	src.expRequired=(PowerOf(level,3)*(150-level))/100
			if("68-98")	src.expRequired=(PowerOf(level,3)*((1911-10*level)/3))/500
			if("98-100")	src.expRequired=(PowerOf(level,3)*(160-level))/100

		//Gen 1 Formulas
		if(src.expFormula=="Fast")	src.expRequired=(4*PowerOf(level,3))/5
		if(src.expFormula=="Medium Fast" || src.expFormula=="Unknown")	src.expRequired=PowerOf(level,3)
		if(src.expFormula=="Medium Slow")	src.expRequired=((6/5)*PowerOf(level,3))-(15*PowerOf(level,2))+(100*level)-140
		if(src.expFormula=="Slow")	src.expRequired=(5*PowerOf(level,3))/4

		//Fluctuating Formulas
		if(src.expFormula=="Fluctuating")
			if("level 1-15")	src.expRequired=(PowerOf(level,3)*((level+1)/3)+24)/50
			if("level 15-36")	src.expRequired=PowerOf(level,3)*((level+14)/50)
			if("level 36-100")	src.expRequired=PowerOf(level,3)*(((level/2)+32)/50)
		src.expRequired=round(src.expRequired)

proc/PetDefeated(var/mob/petOwner,var/mob/Pets/petDefeated)
	var/exp2Give=petDefeated.expYields[1]*petDefeated.level
	if(!petDefeated.isWild)	exp2Give*=1.5
	exp2Give=round(exp2Give/(7*1))	//1 was petWinners.len
	ShowMsg(petOwner,"Your Monster Team\nGained [exp2Give] Experience!",2,5,16,7)
	for(var/mob/Pets/P in petOwner.petsHeld)
		var/thisExp=exp2Give
		if(P.previousOwners && P.previousOwners[1]!=P.owner)	thisExp*=1.5
		//if(P.HoldingItem("Lucky Egg"))	thisExp*=1.5
		var/expYieldID=1
		var/totalEVs=0;for(var/v in P.EVs)	totalEVs+=P.EVs[v]
		for(var/v in P.EVs)	if(totalEVs<510 && P.EVs[v]<255)
			var/pointsLeft=min(510-totalEVs, 255-P.EVs[v])
			totalEVs-=P.EVs[v]
			expYieldID+=1
			P.EVs[v]+=min(pointsLeft,petDefeated.expYields[expYieldID])
			totalEVs+=P.EVs[v]
		P.AddExp(round(thisExp))