obj/HUD/Battle
	layer=8*10000
	BattleOutline
		layer=7.9*10000
		screen_loc="1:23,5:-6"
		icon='BattleOutline.png'
	FoeHPBG
		screen_loc="3:-16,12:16"
		icon='FoeHPBGEdit.png'
	PlayerHPBG
		screen_loc="10,12:16"
		icon='PlayerHPBG.png'
	Bars
		layer=9*10000
		var/curWidth=96
		icon='BarHPGreen.dmi'
		FoeHPBar
			screen_loc="3:28,13:18"
		FoeEXPBar
			icon='BarEXP.dmi'
			screen_loc="3:28,12:18"
		PlayerHPBar
			screen_loc="12:30,13:18"
		PlayerEXPBar
			icon='BarEXP.dmi'
			screen_loc="11:30,12:18"

var/obj/HUD/Battle/BattleOutline/globalBattleOutline=new()

var/obj/HUD/Battle/FoeHPBG/globalFoeHPBG=new()
var/obj/HUD/Battle/PlayerHPBG/globalPlayerHPBG=new()
mob/var/tmp/obj/HUD/Battle/Bars/FoeHPBar/foeHPBar
mob/var/tmp/obj/HUD/Battle/Bars/FoeEXPBar/foeEXPBar
mob/var/tmp/obj/HUD/Battle/Bars/PlayerHPBar/playerHPBar
mob/var/tmp/obj/HUD/Battle/Bars/PlayerEXPBar/playerEXPBar
mob/proc/HPBGs()
	if(!src.client)	return
	if(!src.foeHPBar)
		src.foeHPBar=new
		src.foeEXPBar=new
		src.playerHPBar=new
		src.playerEXPBar=new
	src.client.screen+=globalFoeHPBG
	src.client.screen+=globalPlayerHPBG
	src.client.screen+=src.foeHPBar
	src.client.screen+=src.foeEXPBar
	src.client.screen+=src.playerHPBar
	src.client.screen+=src.playerEXPBar
	var/mob/Pets/thisOpponent=src.activePet.petOpponent
	src.UpdateHPBar("foeHP",thisOpponent,1)
	src.UpdateExpBar("foeEXP",thisOpponent,1)
	src.UpdateHPBar("playerHP",src.activePet,1)
	src.UpdateExpBar("playerEXP",src.activePet,1)
	src.WriteHUDText(3,0,13,22,"FoeName","XOXOXOXOXO")
	src.UpdateHUDText("FoeName","[thisOpponent.GetBattleName()]\\[copytext(thisOpponent.petGender,1,2)]")
	src.WriteHUDText(7,-20,13,22,"FoeLevel","Lv999")
	src.UpdateHUDText("FoeLevel","[PadText("Lv[thisOpponent.level]",5)]Lv[thisOpponent.level]")
	src.WriteHUDText(4,16,12,22,"foeHP","999/999")
	src.UpdateHUDText("foeHP","[thisOpponent.HP]/[thisOpponent.maxHP]")

	src.WriteHUDText(10,26,13,22,"PlayerName","XOXOXOXOXO")
	src.UpdateHUDText("PlayerName","[src.activePet.GetBattleName()]\\[copytext(src.activePet.petGender,1,2)]")
	src.WriteHUDText(14,6,13,22,"PlayerLevel","Lv999")
	src.UpdateHUDText("PlayerLevel","[PadText("Lv[src.activePet.level]",5)]Lv[src.activePet.level]")
	src.WriteHUDText(13,16,12,22,"playerHP","999/999")
	src.UpdateHUDText("playerHP","[src.activePet.HP]/[src.activePet.maxHP]")

mob/proc/UpdateExpBar(var/bar2Update,var/mob/Pets/M,var/instaSet=0)
	var/obj/HUD/Battle/Bars/thisBar=src.vars["[bar2Update]Bar"]
	var/widthScale=round(128*M.exp/M.expRequired)
	thisBar.icon_state="[widthScale]"
	if(instaSet || widthScale<thisBar.curWidth)	thisBar.curWidth=widthScale-1
	while(thisBar.curWidth<widthScale)
		thisBar.curWidth+=1
		if(thisBar.curWidth>128)	break
		thisBar.icon_state="[thisBar.curWidth]"
		sleep(visualDelay)

mob/proc/UpdateHPBar(var/bar2Update,var/mob/Pets/M,var/instaSet=0)
	var/obj/HUD/Battle/Bars/thisBar=src.vars["[bar2Update]Bar"]
	var/widthScale=round(96*M.HP/M.maxHP)
	var/hpDif=max(1,M.displayedHP-M.HP)
	var/barDif=max(1,thisBar.curWidth-widthScale)	//Division by Zero
	var/sleepTime=visualDelay
	if(instaSet || !M.displayedHP)	M.displayedHP=M.HP+1
	spawn(-1)	while(M.displayedHP>M.HP)
		M.displayedHP-=1
		src.UpdateHUDText(bar2Update,"[M.displayedHP]/[M.maxHP]")
		if(!instaSet)
			if(barDif>hpDif)	sleep(sleepTime * (barDif/hpDif))
			else	sleep(sleepTime)
	thisBar.icon_state="[widthScale]"
	if(instaSet || widthScale>thisBar.curWidth)	thisBar.curWidth=widthScale+1
	while(thisBar.curWidth>widthScale)
		thisBar.curWidth-=1
		if(thisBar.curWidth<0)	break
		thisBar.icon_state="[thisBar.curWidth]"
		if(!instaSet)
			if(hpDif>barDif)	sleep(sleepTime * (hpDif/barDif))
			else	sleep(sleepTime)