datum/proc/SelectionReaction(var/mob/M)	return
mob/proc/SelectionChanged(var/datum/newSelection)
	if(istype(newSelection,/datum))	newSelection.SelectionReaction(src)

var/obj/Items/CancelObj/cancelObj=new()
obj/Items/CancelObj
	name="Cancel"
	desc="Close the current menu..."

mob/var/tmp/obj/HUD/ChoiceClicker/choiceClickerRef
obj/HUD/ChoiceClicker
	layer=25*10000
	mouse_opacity=2
	var/textWidth
	var/hudSelection
	var/pointerColumn
	var/pointerRow
	var/textWritten
	icon='BlankIcon.dmi'
	proc/IconSetup(var/icon/I)
		if(textWritten)	I.Scale(src.textWidth,32)
		else	I.Scale(src.textWidth*1.5,64)
	MouseEntered()
		if(usr.curColumn==src.pointerColumn && usr.curRow==src.pointerRow)	return
		usr.choiceClickerRef=src
		usr.curColumn=src.pointerColumn
		usr.curRow=src.pointerRow
		usr.UpdatePointer()
		var/icon/I=new('ChoiceClicker.dmi')
		src.IconSetup(I)
		src.icon=I
	MouseExited()
		if(usr)
			usr.choiceClickerRef=null
			var/icon/I=new('BlankIcon.dmi')
			src.IconSetup(I)
			src.icon=I

mob/var/tmp/curRow=1
mob/var/tmp/curColumn=1
mob/var/tmp/list/hudColumns
mob/var/tmp/hudSelection
mob/var/tmp/hudMenuID=0
mob/var/tmp/choicesOpen
mob/proc/CreateHUDChoices(var/list/choices,var/startLoc,var/columns,var/rows,var/columnSpacing=1,var/rowSpacing=1,var/msgOptn,var/defaultChoice,var/writeText=1)
	if(!istype(choices,/list) || !choices.len)	return
	while(src.choicesOpen)	sleep(1)
	src.choicesOpen=1
	var/list/splitLoc=Split(startLoc,",")
	var/startX=text2num(splitLoc[1])
	var/startXO=0;if(findtext(splitLoc[1],":"))	startXO=text2num(Split(splitLoc[1],":")[2])
	var/startY=text2num(splitLoc[2])
	var/startYO=0;if(findtext(splitLoc[2],":"))	startYO=text2num(Split(splitLoc[2],":")[2])
	var/thisX=startX,thisXO=startXO,thisY=startY,thisYO=startYO
	var/curColumn=1
	var/curRow=1
	var/defaultColumn=1
	var/defaultRow=1
	src.hudMenuID+=1
	src.hudColumns=list()
	var/thisID=src.hudMenuID
	var/defaultColumnList
	if(!src.hudPointer)	src.hudPointer=new
	src.hudPointer.screen_loc=startLoc
	src.client.screen+=src.hudPointer
	var/list/hudText2Clear=list()
	var/list/choiceClickers=list()
	for(var/v in choices)
		if(isnum(v))	v="[v]"
		if(src.hudColumns.len<curColumn)
			src.hudColumns+=curColumn
			src.hudColumns[curColumn]=list()
		src.hudColumns[curColumn]+=v
		src.hudColumns[curColumn][v]="[thisX]:[thisXO],[thisY]:[thisYO]"
		var/hudChoiceTextID="HudChoice[src.hudColumns[curColumn][v]]"
		if(writeText)
			src.WriteHUDText(thisX,thisXO+24,thisY,thisYO+2,hudChoiceTextID,"XOXOXOXOXOXO",11)
			src.UpdateHUDText(hudChoiceTextID,"[v]")
			hudText2Clear+=hudChoiceTextID
		var/obj/HUD/ChoiceClicker/C=new;choiceClickers+=C
		var/textWidth=(length("[v]")+1)*12
		C.textWritten=writeText
		C.textWidth=textWidth;C.MouseExited()
		C.pointerColumn=curColumn;C.pointerRow=curRow
		C.screen_loc="[thisX]:[thisXO+22],[thisY]:[thisYO]"
		if(!writeText)	C.screen_loc="[thisX]:[thisXO+22],[thisY]:[thisYO-26]"
		C.hudSelection=v;src.client.screen+=C
		if(v==defaultChoice)
			defaultColumnList=hudColumns[curColumn]
			src.hudPointer.screen_loc="[thisX]:[thisXO],[thisY]:[thisYO]"
			defaultRow=curRow;defaultColumn=curColumn
		curColumn+=1
		thisX+=columnSpacing
		if(curColumn>columns)
			curColumn=1
			curRow+=1
			thisX=startX
			thisY-=rowSpacing
		if(curRow>rows)	break
	src.curRow=defaultRow
	src.curColumn=defaultColumn
	if(!defaultColumnList)	defaultColumnList=hudColumns[1]
	src.hudSelection=defaultColumnList[src.curRow]
	src.SelectionChanged(src.hudSelection)
	if(msgOptn)	spawn(-1)
		if(src.inBattle)	ShowMsg(src,"[msgOptn]",2,5,16,7)
		else	ShowMsg(src,"[msgOptn]")
	while(src.hudMenuID==thisID)	sleep(1)
	src.msgShown=0
	while(msgOptn && src.viewingMsg)	sleep(1)
	for(var/v in hudText2Clear)	src.UpdateHUDText(v,null)
	src.choicesOpen=0
	src.client.screen-=src.hudPointer
	src.client.screen-=choiceClickers
	return src.hudSelection

proc/QuickChatChoice(var/mob/M,var/thisList,var/thisMsg)
	if(!M)	return
	M.CustBG(13,6,16,8,"QuickChatOptnsBG")
	var/choiceMade=M.CreateHUDChoices(thisList,"13:3,7:16",1,2,1,1,thisMsg)
	if(M)	M.ClearBG("QuickChatOptnsBG")
	return choiceMade

proc/QuickBattleChoice(var/mob/M,var/thisList,var/thisMsg)
	if(!M)	return
	M.CustBG(11,8,16,10,"QuickChoiceBG")
	var/choiceMade=M.CreateHUDChoices(thisList,"11:3,9:16",1,2,1,1,thisMsg)
	if(M)	M.ClearBG("QuickChoiceBG")
	return choiceMade

obj/HUD/Pointer
	icon_state="Pointer"
	layer=21*10000
mob/var/tmp/obj/HUD/Pointer/hudPointer
mob/proc/UpdatePointer()
	if(src.choiceClickerRef)	src.choiceClickerRef.MouseExited()
	if(!src.hudColumns)	return
	var/list/thisColumn=src.hudColumns[src.curColumn]
	src.hudSelection=thisColumn[src.curRow]
	src.SelectionChanged(src.hudSelection)
	src.hudPointer.screen_loc=thisColumn[src.hudSelection]
	src<<sound('Pointer.ogg')
mob/proc/MoveHUDPointer(var/newDir)
	if(src.hudColumns)
		var/colShift=0
		var/rowShift=0
		switch(newDir)
			if(NORTH)	rowShift=-1
			if(SOUTH)	rowShift=1
			if(EAST)	colShift=1
			if(WEST)	colShift=-1
		var/preColumn=src.curColumn
		var/preRow=src.curRow
		if(src.curColumn+colShift>hudColumns.len)	src.curColumn=0
		else	if(src.curColumn+colShift<=0)	src.curColumn=hudColumns.len+1
		src.curColumn+=colShift
		var/list/thisColumn=src.hudColumns[src.curColumn]
		if(src.curRow+rowShift>thisColumn.len)	src.curRow=0
		else	if(src.curRow+rowShift<=0)	src.curRow=thisColumn.len+1
		src.curRow+=rowShift
		if(src.curColumn!=preColumn || src.curRow!=preRow)	src.UpdatePointer()
		return 1