mob/var/chosenOnScreen

obj/HUD/OnScreenText
	var/ID
	New(mob/M,var/SX,var/SY,var/IS)
		if(ismob(M))
			src.icon_state=IS
			screen_loc = "[SX],[SY]"
			M.client.screen+=src
	MessageLetter
		mouse_opacity=0
		icon='MenuText.dmi'
		var/WordID
		New(var/newx,var/newxo,var/newy,var/newyo,var/letter)
			src.icon_state="[letter]"
			src.screen_loc="[newx]:[newxo+8],[newy]:[newyo-2]"
	MenuBGs
		MenuBG
			layer=9*10000
			icon='MenuBG.png'
		MenuOutline
			icon='MenuOutline.dmi'
			layer=9*10000+1

var/list/custBGs=list()
mob/proc/CustBG(var/x1,var/y1,var/x2,var/y2,var/thisID,var/layerBoost=0)
	src.menuLayer+=1
	var/listIndex="[thisID][x1][y1][x2][y2][layerBoost]"
	if(listIndex in custBGs)	src.client.screen+=custBGs[listIndex]
	else
		var/CurX=x1;var/CurY=y1
		var/list/theseBGs=list()
		var/obj/HUD/OnScreenText/MenuBGs/MenuBG/BG=new()
		BG.ID=thisID
		BG.screen_loc="[x1],[y1]"
		var/icon/I=new(BG.icon)
		I.Scale((x2-x1+1)*32,(y2-y1+1)*32)
		BG.icon=I
		theseBGs+=BG
		while(CurX<=x2)
			var/obj/HUD/OnScreenText/MenuBGs/MenuOutline/BGOutline
			var/IS
			if(CurY==y2)	IS="TM"
			else	if(CurX==x2)	IS="MR"
			else	if(CurX==x1)	IS="ML"
			else	if(CurY==y1)	IS="BM"
			if(CurX==x1 && CurY==y2)	IS="TL"
			else	if(CurX==x2 && CurY==y2)	IS="TR"
			else	if(CurX==x1 && CurY==y1)	IS="BL"
			else	if(CurX==x2 && CurY==y1)	IS="BR"
			if(IS)
				BGOutline=new()
				BGOutline.ID=thisID
				BGOutline.icon_state=IS
				BGOutline.screen_loc="[CurX],[CurY]"
				if(layerBoost)	BGOutline.layer+=layerBoost*10000
				theseBGs+=BGOutline
			CurX+=1;if(CurX>x2 && CurY<y2)	{CurX=x1;CurY+=1}
		custBGs+=listIndex
		custBGs[listIndex]=theseBGs
		src.client.screen+=theseBGs
		if(custBGs.len>100)	custBGs.Cut(2)
mob/proc/ClearBG(var/thisID)
	for(var/obj/HUD/OnScreenText/MenuBGs/BG in src.client.screen)	if(BG.ID==thisID)	src.client.screen-=BG

proc/ShowToolTip(var/mob/M,var/thisID,var/x1,var/y1,var/x2,var/y2,var/text2Show)
	if(!M)	return
	M.CustBG(x1,y1,x2,y2,thisID)
	var/yUp=2
	if(y1==y2)	yUp=4
	WriteMessage(M,text2Show,x1,x2,y2,thisID,yUp)
proc/HideToolTip(var/mob/M,var/ThisID)
	if(M && M.client)	for(var/obj/HUD/OnScreenText/O in M.client.screen)
		if(ThisID==O.ID)	M.client.screen-=O

mob/var/tmp/msgShown
mob/var/tmp/viewingMsg
proc/ShowMsg(var/mob/M,var/text2Show,var/x1=2,var/y1=3,var/x2=16,var/y2=5)
	while(M && M.viewingMsg)	sleep(1)
	if(!M)	return
	M.msgShown=1
	M.viewingMsg=1
	M.PlayMenuSound()
	ShowToolTip(M,"ShowMsg",x1,y1,x2,y2,text2Show)
	while(M && M.msgShown)	sleep(1)
	HideToolTip(M,"ShowMsg")
	if(M)	M.viewingMsg=0

proc/ShowBattleMsg(var/mob/Pets/P,var/text2Show)
	if(!P)	return
	var/list/msgMobs=list(P.ownerMob)
	if(P.petOpponent)	msgMobs+=P.petOpponent.ownerMob
	for(var/mob/M in msgMobs)	spawn(-1)
		ShowMsg(M,"[text2Show]",2,5,16,7)
		if(M && M.activePet.petOpponent && M.activePet.petOpponent.ownerMob && M.activePet.petOpponent.ownerMob.viewingMsg)
			M.UpdateHUDText("OppWait","Waiting for [M.activePet.petOpponent.ownerMob]...")
	var/msgReaders=0
	do
		sleep(1)
		msgReaders=0
		for(var/mob/M in msgMobs)	if(M.viewingMsg)	msgReaders+=1
	while(msgReaders)
	for(var/mob/M in msgMobs)	M.UpdateHUDText("OppWait",null)

var/list/writeMsgList=list()
proc/WriteMessage(mob/M,var/text2show,var/StartX,var/EndX,var/StartY,var/ThisID,var/yUp=0)
	var/ThisView=EndX	//Determines when word-wrap should kick in
	var/PixelSpace=12	//sets the spacing between each letter
	var/hudx=StartX	//The begining X in the message, used for resetting on next lines
	var/hudxo=0	//Preps the pixel_x for the loop
	var/hudy=StartY	//Begining y
	var/hudyo=-6+yUp	//Begining pixel_y
	var/CurPos=0	//Which letter position its currently on in the message
	var/LastPos=0	//Goes back to the begining of the last word when wrapping
	var/WordCount=0	//Used to remove the pre-wrapped letters
	var/WordWrapProtection=0	//Automaticaly Breaks on Continual Text
	var/list/TheseLetters=list()	//Contains letters to prevent removing old ones
	var/listIndex="[text2show][StartX][EndX]"
	if(listIndex in writeMsgList)
		M.client.screen+=writeMsgList[listIndex]
		return
	var/list/letterObjList=list()
	while(M)
		CurPos+=1;hudxo+=PixelSpace
		var/letter=copytext(text2show,CurPos,CurPos+1)
		if(!letter)	break
		if(letter=="\\" && CurPos<length(text2show))
			CurPos+=1;letter+=copytext(text2show,CurPos,CurPos+1)
		if(letter==" ")	//skips to next word on spaces
			WordCount+=1;LastPos=CurPos;continue
		if(letter=="\n")	//force to next line
			WordCount+=1;hudx=ThisView;LastPos=CurPos
		var/over32=hudxo+PixelSpace
		if(over32>=32)	over32=1
		else	over32=0
		if(hudx+over32>=ThisView)	//word wrappage!
			hudyo-=24;hudx=StartX;hudxo=0
			if(hudyo==-96)	//only drop the actual y every 3 offsets
				hudy-=3;hudyo=-5+yUp
			if(WordWrapProtection==WordCount)
				hudxo+=PixelSpace
				WordCount+=1;CurPos+=1
				WordWrapProtection=WordCount
			else
				for(var/obj/HUD/OnScreenText/MessageLetter/C1 in TheseLetters)	if(C1.WordID==WordCount)
					letterObjList-=C1
					M.client.screen-=C1
				CurPos=LastPos;WordWrapProtection=WordCount;continue
		if(hudxo>=32)	{hudx+=1;hudxo-=32}	//moves to next x and resets x offset
		var/newType="/obj/HUD/OnScreenText/MessageLetter"
		var/obj/HUD/OnScreenText/MessageLetter/C=new newType(hudx,hudxo,hudy,hudyo,letter)
		C.ID=ThisID
		TheseLetters+=C
		if(SlimLetter(letter))	hudxo-=8
		C.WordID=WordCount
		M.client.screen+=C
		letterObjList+=C
	writeMsgList+=listIndex
	writeMsgList[listIndex]=letterObjList
	if(writeMsgList.len>100)	writeMsgList.Cut(2)