var/list/storedIcons=list()
proc/StoreIcon(var/iconID,var/icon)
	storedIcons+=iconID
	storedIcons[iconID]=icon

proc/ScaleIconHeight(var/icon/I,var/thisSize,var/iconName)
	var/thisIconID="[iconName]H[thisSize]"
	if(thisIconID in storedIcons)
		return storedIcons[thisIconID]
	I=new(I)
	if(thisSize<I.Height())
		var/scalePercent=thisSize/I.Height()
		I.Scale(I.Width()*scalePercent,I.Height()*scalePercent)
	StoreIcon(thisIconID,I)
	return I

proc/ScaleIconWidth(var/icon/I,var/thisSize)
	var/thisIconID="[I]W[thisSize]"
	if(thisIconID in storedIcons)	return storedIcons[thisIconID]
	I=new(I)
	if(thisSize<I.Width())
		var/scalePercent=thisSize/I.Width()
		I.Scale(I.Width()*scalePercent,I.Height()*scalePercent)
	StoreIcon(thisIconID,I)
	return I

proc/FlipIcon(var/icon/I)
	var/thisIconID="[I]FLIPPED"
	if(thisIconID in storedIcons)	return storedIcons[thisIconID]
	I=new(I)
	I.Flip(WEST)
	StoreIcon(thisIconID,I)
	return I

proc/InvertIcon(var/icon/I,var/iconName)
	var/thisIconID="[iconName]INVERT"
	if(thisIconID in storedIcons)	return storedIcons[thisIconID]
	var/icon/II=new(I)
	II.MapColors(-1,0,0, 0,-1,0, 0,0,-1, 1,1,1)
	StoreIcon(thisIconID,II)
	return II

proc/GetLowestPixel(var/icon/I,var/IS,var/thisDir)
	var/thisIconID="[I][IS][thisDir]LOWEST"
	if(thisIconID in storedIcons)	return storedIcons[thisIconID]
	I=new(I)
	for(var/y=1;y<=I.Height();y++)
		for(var/x=1;x<=I.Width();x++)
			var/pixColor=I.GetPixel(x,y,IS,thisDir,1,null)
			if(pixColor)
				StoreIcon(thisIconID,y)
				return y