obj/InteractionExtender
	layer=10
	Interact(var/mob/M)
		for(var/atom/A in oview(1,src)-M)
			if(istype(A,/mob/Player))	continue
			if(A.type!=src.type)	//Prevent extending to extenders forever
				if(M.IsFacing(A) && A.Interact(M))	return 1

client/Click(object,location,control,params)
	if(findtext(params,"right"))	{src.mob.CancelVerb();return}
	if(istype(object,/obj/HUD/ToolTips))	return ..()
	if(src.mob.hudColumns)
		if(istype(object,/obj/HUD/ChoiceClicker))
			var/obj/HUD/ChoiceClicker/C=object
			src.mob.hudSelection=C.hudSelection
		else	return
	if(findtext(params,"left"))	if(src.mob.InteractVerb())	return
	return ..()

mob/proc/AdvanceMessage()
	if(src.msgShown)
		src.msgShown=0
		src.PlayMenuSound(forcePlay=1)
		return 1

mob/proc/IsBusy()
	var/busyMsg
	if(src.inBattle)	busyMsg="They are already in a battle..."
	if(src.isLoading)	busyMsg="They are loading..."
	if(src.viewingMsg)	busyMsg="They are reading..."
	if(src.hudColumns)	busyMsg="They are busy..."
	if(src.mainMenuOpen)	busyMsg="They are checking the menu..."
	return busyMsg

proc/EitherBusy(var/mob/M1,var/mob/M2)
	if(!M1 || !M2)	return 1
	var/failMsg=M1.IsBusy()
	if(!failMsg)	failMsg=M2.IsBusy()
	if(failMsg)
		ShowMsg(M1,failMsg)
		return 1

mob/Player/Interact(var/mob/M)
	if(QuickChatChoice(M,list("Close","Battle"),"This is another player.\nTheir name is [src.key].")=="Battle")
		if(!M.encounterRate)	{ShowMsg(src,"[M] has battles disabled.");return}
		if(EitherBusy(M,src))	return
		if(QuickChatChoice(src,list("Decline","Accept"),"[M] has challenged you to a Monster battle!")=="Accept")
			if(EitherBusy(src,M))	return
			spawn(-1)	src.StartBattleAgainst(M.activePet)
	return 1

atom/proc/Interact()	return
obj/var/list/chatMsgs
obj/var/list/pickMsgs
obj/Interact(var/mob/M)
	if(src.pickMsgs)
		ShowMsg(M,pick(src.pickMsgs))
		return 1
	if(src.chatMsgs)
		for(var/v in src.chatMsgs)	ShowMsg(M,v)
		return 1

mob/verb/InteractVerb()
	set hidden=1
	if(src.isLoading)	return 1
	if(src.hudColumns)
		src.hudMenuID+=1
		src.hudColumns=null
		src.PlayMenuSound('Select.ogg')
		return 1
	if(src.mainMenuOpen)	return 1
	if(src.gettingNumber)	return 1
	if(src.AdvanceMessage())	return 1
	if(src.inBattle)	return 1
	for(var/atom/A in oview(1,src)-src)
		if(istype(A,/mob/Player))	continue
		if(src.IsFacing(A) && A.Interact(src))	return 1
	for(var/mob/Player/P in oview(1,src)-src)
		if(src.IsFacing(P) && P.Interact(src))	return 1
	for(var/mob/Pets/P in oview(1,src))
		if(src.IsFacing(P) && P.ownerMob==src)	{src.CancelVerb();return 1}

mob/verb/CancelVerb()
	set hidden=1
	if(src.hudColumns)
		src.hudMenuID+=1
		src.hudColumns=null
		src.hudSelection=null
		src.PlayMenuSound('Cancel.ogg')
		return 1
	if(src.AdvanceMessage())	return 1
	if(src.vehicleRef)	if(src.vehicleRef.ExitVehicle(src))	{src.activePet.FollowOwner();return 1}
	if(!src.mainMenuOpen)	{src.ShowMainMenu();return 1}