mob/proc/AddItem(var/obj/Items/thisItem,var/amt=1)
	if(!src.inventory)	src.inventory=list()
	for(var/obj/Items/I in src.inventory)	if(I.type==thisItem.type && I.name==thisItem.name)	{I.suffix="[text2num(I.suffix)+amt]";return}
	src.inventory+=thisItem
	thisItem.suffix="[amt]"

mob/proc/RemoveItem(var/obj/Items/thisItem,var/amt=1)
	if(thisItem in src.inventory)
		thisItem.suffix="[text2num(thisItem.suffix)-amt]"
		if(text2num(thisItem.suffix)<=0)	src.inventory-=thisItem

obj/Items/SelectionReaction(var/mob/M)
	HideToolTip(M,"ItemDesc")
	ShowToolTip(M,"ItemDesc",1,2,17,6,src.desc)
	M.CustBG(1,7,3,9,"ItemDesc")
	M.itemDisplay.icon=src.icon
	M.itemDisplay.icon_state=src.icon_state
	var/icon/I=new(src.icon)
	var/thisX=RoundUp(32*32/I.Width())
	var/thisY=RoundUp(32*32/I.Height())
	M.itemDisplay.screen_loc="1:[thisX],7:[thisY]"

proc/FourthRoot(var/baseNumber)
	var/returnValue=baseNumber
	for(var/i=1; i<=2; i++)	returnValue=sqrt(returnValue)
	return returnValue

obj/Items
	suffix="1"
	var/maxBuy
	var/price=0
	var/battleUse
	icon='Items.dmi'
	layer=11*10000
	proc/Use(var/mob/M)	if(M)	M.RemoveItem(src)
	proc/BoughtBy(var/mob/M,var/amt)
		var/obj/Items/newItem=new src.type
		if(M)	M.AddItem(newItem,amt)
	Catchers
		battleUse=1
		screen_loc="4:16,9"
		var/catchRate
		Use(var/mob/M)
			var/mob/Pets/P=M.activePet.petOpponent
			P.BattleScreenEffect("StoneDeploy")
			P.battleFront.invisibility=1
			P.BattleSoundEffect('Absorb2.ogg')
			var/obj/Items/Catchers/thisBall=new src.type
			M.client.screen+=thisBall
			ShowBattleMsg(M.activePet,"[M]\nused [src]!")
			var/bonusStatus=P.GetStatusEffectCatchRate()
			var/catchChance=( ((3*P.maxHP-2*P.HP)*P.catchRate*src.catchRate) / (3*P.maxHP) )*bonusStatus
			var/shakeChance=round(65536/FourthRoot(255/catchChance))
			for(var/i=1; i<=4; i++)
				if(!M)	return
				var/shakePass=rand(0,65535)
				if(!P.isWild)	shakePass=shakeChance+1
				if(shakePass>shakeChance)
					P.BattleScreenEffect("PokeEscape")
					M.client.screen-=thisBall
					P.BattleSoundEffect('Heal6.ogg')
					spawn(4)	if(P)	P.battleFront.invisibility=0
					ShowBattleMsg(M.activePet,"[P.WildName()]\nbroke free!")
					return ..()
				else
					if(i<4)
						P.BattleSoundEffect('Chime1.ogg')
						flick("[thisBall.icon_state] Shake",thisBall)
					else
						P.BattleSoundEffect('Right.ogg')
						flick("[thisBall.icon_state] Catch",thisBall)
						thisBall.icon_state="[thisBall.icon_state] Catch"
				sleep(10)
			M.ChangeMusic('001-Victory01.mid',0)
			if(P.isShiny)	M.GiveMedal("Bright Soul")
			M.GiveMedal("Captor")
			ShowBattleMsg(M.activePet,"[M] caught\n[P.WildName()]!")
			M.client.screen-=thisBall
			P.SetLevel(5)
			M.AddPet(P)
			P.SetCaptureInfo(src.name,M.curZone)
			M.activePet.Victory("Capture")
			return ..()
		Stones
			icon='Crystals.dmi'
			Soul_Stone
				price=200
				catchRate=1
				icon_state="Soul Stone"
				desc="A Magical Crystal used to catch Monsters."
			Great_Stone
				price=600
				catchRate=1.5
				icon_state="Great Stone"
				desc="A Magical Crystal used to catch Monsters. More effective than a Soul Stone."
			Ultra_Stone
				price=1200
				catchRate=2
				icon_state="Ultra Stone"
				desc="A Magical Crystal used to catch Monsters. More effective than a Great Stone."
			Exp_Stone
				price=1500
				catchRate=1
				icon_state="Exp Stone"
				desc="A Magical Crystal used to catch Monsters. Monsters caught with this Stone will gain 10% more Experience from battle."
			Heat_Stone
				price=2000
				catchRate=1
				icon_state="Heat Stone"
				desc="A Magical Crystal used to catch Monsters. Has a 10% chance to cause Burn."
			Frost_Stone
				price=2500
				catchRate=1
				icon_state="Frost Stone"
				desc="A Magical Crystal used to catch Monsters. Has a 10% chance to cause Freeze."
		Poke_Balls
			Poke_Ball
				price=200
				catchRate=1
				icon_state="Poke Ball"
				desc="A Ball thrown at wild Pokmon to catch them."
			Great_Ball
				price=600
				catchRate=1.5
				icon_state="Great Ball"
				desc="A Ball for catching wild Pokmon. More effective than a Pok Ball."
			Ultra_Ball
				price=1200
				catchRate=2
				icon_state="Ultra Ball"
				desc="A Ball for catching wild Pokmon. More effective than a Great Ball."