mob/proc/AddMovementMacros()	//Call this in Login()
	winset(src,"ID.W","parent=macro;name=W;command='StartMoving North'")
	winset(src,"ID.W+UP","parent=macro;name=W+UP;command='StopMoving North'")
	winset(src,"ID.S","parent=macro;name=S;command='StartMoving South'")
	winset(src,"ID.S+UP","parent=macro;name=S+UP;command='StopMoving South'")
	winset(src,"ID.D","parent=macro;name=D;command='StartMoving East'")
	winset(src,"ID.D+UP","parent=macro;name=D+UP;command='StopMoving East'")
	winset(src,"ID.A","parent=macro;name=A;command='StartMoving West'")
	winset(src,"ID.A+UP","parent=macro;name=A+UP;command='StopMoving West'")

	winset(src,"ID.NORTH","parent=macro;name=NORTH;command='StartMoving North'")
	winset(src,"ID.NORTH+UP","parent=macro;name=NORTH+UP;command='StopMoving North'")
	winset(src,"ID.SOUTH","parent=macro;name=SOUTH;command='StartMoving South'")
	winset(src,"ID.SOUTH+UP","parent=macro;name=SOUTH+UP;command='StopMoving South'")
	winset(src,"ID.EAST","parent=macro;name=EAST;command='StartMoving East'")
	winset(src,"ID.EAST+UP","parent=macro;name=EAST+UP;command='StopMoving East'")
	winset(src,"ID.WEST","parent=macro;name=WEST;command='StartMoving West'")
	winset(src,"ID.WEST+UP","parent=macro;name=WEST+UP;command='StopMoving West'")

mob/var
	isMoving
	movementDelay=0.5
	list/movementDirs

atom/movable/var/canCross=0
atom/movable/var/canBeCrossed=0
mob/canCross=1
mob/canBeCrossed=1
atom/movable/Cross(var/atom/movable/M)
	if(src.canCross && M.canBeCrossed)	return 1
	return ..()

mob/Player/Move(var/newLoc,var/newDir)
	if(src.MoveHUDPointer(newDir))	return
	if(src.inBattle)	return
	if(src.isLoading)	return
	if(src.viewingMsg)	return
	if(src.mainMenuOpen)	return
	if(src.gettingNumber)	return
	return ..()

mob/Player/Move()
	.=..()
	if(. && src.activePet)	step_to(src.activePet,src,1)

var/list/moveDirs=list("North"=NORTH,"South"=SOUTH,"East"=EAST,"West"=WEST)
mob/verb
	StartMoving(var/moveDir as null|text)
		set hidden=1;set instant=1
		if(!src.movementDirs)	src.movementDirs=list()
		if(src.choicesOpen)	{step(src,moveDirs[moveDir]);return}
		src.movementDirs+=moveDir
		src.MovementLoop()
	StopMoving(var/moveDir as null|text)
		set hidden=1;set instant=1
		if(!src.movementDirs)	src.movementDirs=list()
		src.movementDirs-=moveDir

mob/proc/IsMovingInDir(var/moveDir)
	if(moveDir in src.movementDirs)	return 1

mob/proc/MovementLoop()
	if(src.isMoving)	return
	src.isMoving=1
	while(src.movementDirs.len)
		if(src.choicesOpen)	break
		var/list/stepDirs=list()
		if(("North" in src.movementDirs) && ("South" in src.movementDirs))
		else
			if("North" in src.movementDirs)	stepDirs+=NORTH
			if("South" in src.movementDirs)	stepDirs+=SOUTH
		if(("East" in src.movementDirs) && ("West" in src.movementDirs))
		else
			if("East" in src.movementDirs)	stepDirs+=EAST
			if("West" in src.movementDirs)	stepDirs+=WEST
		for(var/stepDir in stepDirs)	step(src,stepDir)
		sleep(src.movementDelay)
	src.isMoving=0