mob/proc/ClearPPText()
	src.ClearBG("PPBG")
	HideToolTip(src,"BattleMoveDesc")
	src.UpdateHUDText("BattlePPText",null)
	src.UpdateHUDText("BattleMoveType",null)
	src.UpdateHUDText("BattleMoveTypeText",null)

obj/Moves
	var/longDesc
	var/elementType
	var/category
	var/power
	var/accuracy
	var/PP
	var/maxPP
	var/introduced
	var/tmp/list/causesEffects
	var/tmp/list/effectsStatStages
	var/effectIcon="DeathX"
	var/soundEffect='Buzzer1.ogg'
	var/isNew=1
	var/targetSelf=0
	var/stealsLife=0
	New()
		if(src.isNew)
			src.isNew=0
			src.PP=src.maxPP
		return ..()
	SelectionReaction(var/mob/M)
		if(M.inBattle)
			HideToolTip(M,"BattleMoveDesc")
			ShowToolTip(M,"BattleMoveDesc",2,8,16,8,"[src.desc]")
			var/thisCategory=src.category
			if(thisCategory=="Special")	thisCategory="Magic"
			if(src.power)	ShowToolTip(M,"BattleMoveDesc",2,9,9,9,"[src.power] [thisCategory] Attack")
			M.WriteHUDText(12,16,7,-8,"BattlePPText","MP: XXX/XXX")
			M.UpdateHUDText("BattlePPText","MP:  [src.PP]/[src.maxPP]")
			M.WriteHUDText(12,16,6,0,"BattleMoveType","Element:")
			M.UpdateHUDText("BattleMoveType","Element:")
			M.WriteHUDText(12,16,6,-24,"BattleMoveTypeText","Some Long Type")
			M.UpdateHUDText("BattleMoveTypeText","[src.elementType]")
	proc/UseMove(var/mob/Pets/P)
		src.PP-=1
		ShowBattleMsg(P,"[P.WildName()] used\n[src]!")
		if(src.accuracy && !prob(src.accuracy*(1/1)))
			P.BattleSoundEffect('Wind4.ogg')
			ShowBattleMsg(P,"[src.name] missed!")
		else
			var/mob/Pets/thisOpponent=P.petOpponent
			if(src.targetSelf)	thisOpponent=P
			thisOpponent.BattleScreenEffect(src.effectIcon)
			P.BattleSoundEffect(src.soundEffect)
			var/damageDealt=0
			if(src.power)	damageDealt=P.DamagePet(thisOpponent,src)
			if(src.stealsLife && damageDealt)	P.AddHP(RoundUp(damageDealt/2))
			for(var/stat in src.effectsStatStages)
				var/canMod=0
				var/fellRose="fell"
				var/modifier=src.effectsStatStages[stat]
				var/modChance=100
				if(istype(modifier,/list))
					modChance=modifier[2]
					modifier=text2num(modifier[1])
				if(modifier<0)	if(thisOpponent.statStages[stat]+modifier>=-6)	canMod=1
				if(modifier>0)
					fellRose="increased"
					if(thisOpponent.statStages[stat]+modifier<=6)	canMod=1
				if(rand(1,100)>modChance)	canMod=2
				if(canMod==1)
					thisOpponent.statStages[stat]+=modifier
					ShowBattleMsg(P,"[thisOpponent.WildName()]'s [uppertext(stat)] [fellRose]!")
				else	if(canMod!=2)	ShowBattleMsg(P,"[thisOpponent.WildName()]'s [uppertext(stat)] was not effected...")
			for(var/effect in src.causesEffects)	if(rand(1,100)<=src.causesEffects[effect])	thisOpponent.AddEffect(effect)
	Absorb
		stealsLife=0.5
		effectIcon="HealBall"
		soundEffect='Heal3.ogg'
		desc="Steals 1/2 of the damage inflicted."
		longDesc="A nutrient-draining attack. The user's HP is restored by half the damage taken by the target."

		elementType="Grass"
		category="Special"
		power=20
		accuracy=100
		maxPP=25
		introduced="Generation I"
	Acid
		effectIcon="Acid"
		soundEffect='Poison.ogg'
		effectsStatStages=list("specialDefense"=list("-1",10))
		desc="An attack that may lower DEFENSE."
		longDesc="The foe is attacked with a spray of harsh acid. It may also lower the targets Sp. Def stat."

		elementType="Poison"
		category="Special"
		power=40
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Acid_Armor
		elementType="Poison"
		category="Status"
		power=0
		accuracy=0
		maxPP=40
		introduced="Generation I"
	Agility
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Amnesia
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=20
		introduced="Generation I"
	Aurora_Beam
		elementType="Ice"
		category="Special"
		power=65
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Barrage
		elementType="Normal"
		category="Physical"
		power=15
		accuracy=85
		maxPP=20
		introduced="Generation I"
	Barrier
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Bide
		elementType="Normal"
		category="Physical"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Bind
		elementType="Normal"
		category="Physical"
		power=15
		accuracy=85
		maxPP=20
		introduced="Generation I"
	Bite
		effectIcon="PointDamage"
		soundEffect='Blow1.ogg'
		causesEffects=list("Flinch"=30)
		desc="An attack that may cause flinching."
		longDesc="The target is bitten with viciously sharp fangs. It may make the target flinch."

		elementType="Dark"
		category="Physical"
		power=60
		accuracy=100
		maxPP=25
		introduced="Generation I"
	Blizzard
		elementType="Ice"
		category="Special"
		power=120
		accuracy=70
		maxPP=5
		introduced="Generation I"
	Body_Slam
		elementType="Normal"
		category="Physical"
		power=85
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Bone_Club
		elementType="Ground"
		category="Physical"
		power=65
		accuracy=85
		maxPP=20
		introduced="Generation I"
	Bonemerang
		elementType="Ground"
		category="Physical"
		power=50
		accuracy=90
		maxPP=10
		introduced="Generation I"
	Bubble
		effectIcon="Bubble"
		soundEffect='Dive.ogg'
		effectsStatStages=list("speed"=list("-1",10))
		desc="An attack that may reduce SPEED."
		longDesc="A spray of countless bubbles is jetted at the opposing team. It may also lower the targets' Speed stats."

		elementType="Water"
		category="Special"
		power=20
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Bubblebeam
		elementType="Water"
		category="Special"
		power=65
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Clamp
		elementType="Water"
		category="Physical"
		power=35
		accuracy=75
		maxPP=10
		introduced="Generation I"
	Comet_Punch
		elementType="Normal"
		category="Physical"
		power=18
		accuracy=85
		maxPP=15
		introduced="Generation I"
	Confuse_Ray
		elementType="Ghost"
		category="Status"
		power=0
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Confusion
		elementType="Psychic"
		category="Special"
		power=50
		accuracy=100
		maxPP=25
		introduced="Generation I"
	Constrict
		elementType="Normal"
		category="Physical"
		power=10
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Conversion
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Counter
		elementType="Fighting"
		category="Physical"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Crabhammer
		elementType="Water"
		category="Physical"
		power=90
		accuracy=90
		maxPP=10
		introduced="Generation I"
	Cut
		elementType="Normal"
		category="Physical"
		power=50
		accuracy=95
		maxPP=30
		introduced="Generation I"
	Defense_Curl
		targetSelf=1
		effectIcon="LightOrb"
		soundEffect='Barrier.ogg'
		effectsStatStages=list("defense"=1)
		desc="Heightens the user's DEFENSE."
		longDesc="The user curls up to conceal weak spots and raise its DEFENSE stat."

		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=40
		introduced="Generation I"
	Dig
		elementType="Ground"
		category="Physical"
		power=80
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Disable
		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Dizzy_Punch
		elementType="Normal"
		category="Physical"
		power=70
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Double_Kick
		effectIcon="Double"
		soundEffect='Close2.ogg'
		desc="A double kicking attack."
		longDesc="The target is quickly kicked twice in succession using both feet."

		elementType="Fighting"
		category="Physical"
		power=30
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Double_Team
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=15
		introduced="Generation I"
	Double_Edge
		name="Double-Edge"
		elementType="Normal"
		category="Physical"
		power=120
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Doubleslap
		elementType="Normal"
		category="Physical"
		power=15
		accuracy=85
		maxPP=10
		introduced="Generation I"
	Dragon_Rage
		elementType="Dragon"
		category="Special"
		power=0
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Dream_Eater
		elementType="Psychic"
		category="Special"
		power=100
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Drill_Peck
		elementType="Flying"
		category="Physical"
		power=80
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Earthquake
		elementType="Ground"
		category="Physical"
		power=100
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Egg_Bomb
		elementType="Normal"
		category="Physical"
		power=100
		accuracy=75
		maxPP=10
		introduced="Generation I"
	Ember
		effectIcon="Fire"
		soundEffect='Fire1.ogg'
		causesEffects=list("Burn"=10)
		desc="An attack that may inflict a burn."
		longDesc="The target is attacked with small flames. It may also leave the target with a burn."

		elementType="Fire"
		category="Special"
		power=40
		accuracy=100
		maxPP=25
		introduced="Generation I"
	Explosion
		elementType="Normal"
		category="Physical"
		power=250
		accuracy=100
		maxPP=5
		introduced="Generation I"
	Fire_Blast
		elementType="Fire"
		category="Special"
		power=120
		accuracy=85
		maxPP=5
		introduced="Generation I"
	Fire_Punch
		elementType="Fire"
		category="Physical"
		power=75
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Fire_Spin
		elementType="Fire"
		category="Special"
		power=35
		accuracy=85
		maxPP=15
		introduced="Generation I"
	Fissure
		elementType="Ground"
		category="Physical"
		power=0
		accuracy=30
		maxPP=5
		introduced="Generation I"
	Flamethrower
		elementType="Fire"
		category="Special"
		power=95
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Flash
		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Fly
		elementType="Flying"
		category="Physical"
		power=90
		accuracy=95
		maxPP=15
		introduced="Generation I"
	Focus_Energy
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Fury_Attack
		elementType="Normal"
		category="Physical"
		power=15
		accuracy=85
		maxPP=20
		introduced="Generation I"
	Fury_Swipes
		elementType="Normal"
		category="Physical"
		power=18
		accuracy=80
		maxPP=15
		introduced="Generation I"
	Glare
		elementType="Normal"
		category="Status"
		power=0
		accuracy=90
		maxPP=30
		introduced="Generation I"
	Growl
		effectIcon="Fear"
		soundEffect='Monster2.ogg'
		effectsStatStages=list("attack"=-1)
		desc="Reduces the foe's ATTACK."
		longDesc="The user growls in an endearing way, making the opposing team less wary. The foes' Attack stats are lowered."

		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=40
		introduced="Generation I"
	Growth
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=40
		introduced="Generation I"
	Guillotine
		elementType="Normal"
		category="Physical"
		power=0
		accuracy=30
		maxPP=5
		introduced="Generation I"
	Gust
		elementType="Flying"
		category="Special"
		power=40
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Harden
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Haze
		elementType="Ice"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Headbutt
		elementType="Normal"
		category="Physical"
		power=70
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Hi_Jump_Kick
		elementType="Fighting"
		category="Physical"
		power=130
		accuracy=90
		maxPP=10
		introduced="Generation I"
	Horn_Attack
		elementType="Normal"
		category="Physical"
		power=65
		accuracy=100
		maxPP=25
		introduced="Generation I"
	Horn_Drill
		elementType="Normal"
		category="Physical"
		power=0
		accuracy=30
		maxPP=5
		introduced="Generation I"
	Hydro_Pump
		elementType="Water"
		category="Special"
		power=120
		accuracy=80
		maxPP=5
		introduced="Generation I"
	Hyper_Beam
		elementType="Normal"
		category="Special"
		power=150
		accuracy=90
		maxPP=5
		introduced="Generation I"
	Hyper_Fang
		elementType="Normal"
		category="Physical"
		power=80
		accuracy=90
		maxPP=15
		introduced="Generation I"
	Hypnosis
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=60
		maxPP=20
		introduced="Generation I"
	Ice_Beam
		elementType="Ice"
		category="Special"
		power=95
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Ice_Punch
		elementType="Ice"
		category="Physical"
		power=75
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Jump_Kick
		elementType="Fighting"
		category="Physical"
		power=85
		accuracy=95
		maxPP=25
		introduced="Generation I"
	Karate_Chop
		elementType="Fighting"
		category="Physical"
		power=50
		accuracy=100
		maxPP=25
		introduced="Generation I"
	Kinesis
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=80
		maxPP=15
		introduced="Generation I"
	Leech_Life
		stealsLife=0.5
		effectIcon="SoulSteal"
		soundEffect='Heal4.ogg'
		desc="Steals 1/2 of the damage inflicted."
		longDesc="The user drains the target's blood. The user's HP is restored by half of the damage taken by the target."

		elementType="Bug"
		category="Physical"
		power=20
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Leech_Seed
		effectIcon="LeechSeed"
		soundEffect='Heal4.ogg'
		causesEffects=list("Leech Seed"=100)
		desc="Steals HP from the foe on every turn."
		longDesc="A seed is planted on the foe. It steals some HP from the foe to heal the user on every turn."

		elementType="Grass"
		category="Status"
		power=0
		accuracy=90
		maxPP=10
		introduced="Generation I"
	Leer
		effectIcon="ShieldOff"
		soundEffect='Fall.ogg'
		effectsStatStages=list("defense"=-1)
		desc="Reduces the foe's DEFENSE."
		longDesc="The foe is given an intimidating leer with sharp eyes. The targets Defense stat is reduced."

		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Lick
		elementType="Ghost"
		category="Physical"
		power=20
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Light_Screen
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Lovely_Kiss
		elementType="Normal"
		category="Status"
		power=0
		accuracy=75
		maxPP=10
		introduced="Generation I"
	Low_Kick
		elementType="Fighting"
		category="Physical"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Meditate
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=40
		introduced="Generation I"
	Mega_Drain
		elementType="Grass"
		category="Special"
		power=40
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Mega_Kick
		elementType="Normal"
		category="Physical"
		power=120
		accuracy=75
		maxPP=5
		introduced="Generation I"
	Mega_Punch
		elementType="Normal"
		category="Physical"
		power=80
		accuracy=85
		maxPP=20
		introduced="Generation I"
	Metronome
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Mimic
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Minimize
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=20
		introduced="Generation I"
	Mirror_Move
		elementType="Flying"
		category="Status"
		power=0
		accuracy=0
		maxPP=20
		introduced="Generation I"
	Mist
		elementType="Ice"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Night_Shade
		elementType="Ghost"
		category="Special"
		power=0
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Pay_Day
		elementType="Normal"
		category="Physical"
		power=40
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Peck
		elementType="Flying"
		category="Physical"
		power=35
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Petal_Dance
		elementType="Grass"
		category="Special"
		power=120
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Pin_Missile
		elementType="Bug"
		category="Physical"
		power=14
		accuracy=85
		maxPP=20
		introduced="Generation I"
	Poison_Gas
		effectIcon="PoisonCloud"
		soundEffect='Poison.ogg'
		causesEffects=list("Poison"=100)
		desc="A move that may poison the foe."
		longDesc="A cloud of poison gas is sprayed in the foes face. It may poison the target."

		elementType="Poison"
		category="Status"
		power=0
		accuracy=85
		maxPP=40
		introduced="Generation I"
	Poison_Sting
		effectIcon="Poison"
		soundEffect='Poison.ogg'
		causesEffects=list("Poison"=30)
		//desc="An attack that may poison the target."
		desc="An attack that may cause POISON"
		longDesc="The user stabs the target with a poisonous stinger. This may also poison the target."

		elementType="Poison"
		category="Physical"
		power=15
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Poisonpowder
		elementType="Poison"
		category="Status"
		power=0
		accuracy=75
		maxPP=35
		introduced="Generation I"
	Pound
		elementType="Normal"
		category="Physical"
		power=40
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Psybeam
		elementType="Psychic"
		category="Special"
		power=65
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Psychic
		elementType="Psychic"
		category="Special"
		power=90
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Psywave
		elementType="Psychic"
		category="Special"
		power=0
		accuracy=80
		maxPP=15
		introduced="Generation I"
	Quick_Attack
		elementType="Normal"
		category="Physical"
		power=40
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Rage
		elementType="Normal"
		category="Physical"
		power=20
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Razor_Leaf
		elementType="Grass"
		category="Physical"
		power=55
		accuracy=95
		maxPP=25
		introduced="Generation I"
	Razor_Wind
		elementType="Normal"
		category="Special"
		power=80
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Recover
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Reflect
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=20
		introduced="Generation I"
	Rest
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Roar
		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Rock_Slide
		elementType="Rock"
		category="Physical"
		power=75
		accuracy=90
		maxPP=10
		introduced="Generation I"
	Rock_Throw
		elementType="Rock"
		category="Physical"
		power=50
		accuracy=90
		maxPP=15
		introduced="Generation I"
	Rolling_Kick
		elementType="Fighting"
		category="Physical"
		power=60
		accuracy=85
		maxPP=15
		introduced="Generation I"
	Sand_attack
		name="Sand-attack"
		elementType="Ground"
		category="Status"
		power=0
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Scratch
		effectIcon="Slash"
		soundEffect='Slash1.ogg'
		desc="Scratches with sharp claws."
		longDesc="Hard, pointed, and sharp claws rake the target to inflict damage."

		elementType="Normal"
		category="Physical"
		power=40
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Screech
		elementType="Normal"
		category="Status"
		power=0
		accuracy=85
		maxPP=40
		introduced="Generation I"
	Seismic_Toss
		elementType="Fighting"
		category="Physical"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Selfdestruct
		elementType="Normal"
		category="Physical"
		power=200
		accuracy=100
		maxPP=5
		introduced="Generation I"
	Sharpen
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Sing
		effectIcon="Music"
		soundEffect='Jigglypuff.ogg'
		causesEffects=list("Sleep"=100)
		desc="May cause the foe to fall asleep."
		longDesc="A soothing lullaby is sung in a calming voice that puts the target into a deep slumber."

		elementType="Normal"
		category="Status"
		power=0
		accuracy=55
		maxPP=15
		introduced="Generation I"
	Skull_Bash
		elementType="Normal"
		category="Physical"
		power=100
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Sky_Attack
		elementType="Flying"
		category="Physical"
		power=140
		accuracy=90
		maxPP=5
		introduced="Generation I"
	Slam
		elementType="Normal"
		category="Physical"
		power=80
		accuracy=75
		maxPP=20
		introduced="Generation I"
	Slash
		elementType="Normal"
		category="Physical"
		power=70
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Sleep_Powder
		elementType="Grass"
		category="Status"
		power=0
		accuracy=75
		maxPP=15
		introduced="Generation I"
	Sludge
		elementType="Poison"
		category="Special"
		power=65
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Smog
		elementType="Poison"
		category="Special"
		power=20
		accuracy=70
		maxPP=20
		introduced="Generation I"
	Smokescreen
		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Softboiled
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Solarbeam
		elementType="Grass"
		category="Special"
		power=120
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Sonicboom
		elementType="Normal"
		category="Special"
		power=0
		accuracy=90
		maxPP=20
		introduced="Generation I"
	Spike_Cannon
		elementType="Normal"
		category="Physical"
		power=20
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Splash
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=40
		introduced="Generation I"
	Spore
		elementType="Grass"
		category="Status"
		power=0
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Stomp
		elementType="Normal"
		category="Physical"
		power=65
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Strength
		elementType="Normal"
		category="Physical"
		power=80
		accuracy=100
		maxPP=15
		introduced="Generation I"
	String_Shot
		effectIcon="LightVine"
		soundEffect='Wind1.ogg'
		effectsStatStages=list("speed"=-1)
		desc="A move that lowers the foe's SPEED."
		longDesc="	The targets are bound with silk blown from the user's mouth. This silk reduces the targets' Speed stat."

		elementType="Bug"
		category="Status"
		power=0
		accuracy=95
		maxPP=40
		introduced="Generation I"
	Struggle
		elementType="Normal"
		category="Physical"
		power=50
		accuracy=100
		maxPP=0
		introduced="Generation I"
	Stun_Spore
		elementType="Grass"
		category="Status"
		power=0
		accuracy=75
		maxPP=30
		introduced="Generation I"
	Submission
		elementType="Fighting"
		category="Physical"
		power=80
		accuracy=80
		maxPP=25
		introduced="Generation I"
	Substitute
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Super_Fang
		elementType="Normal"
		category="Physical"
		power=0
		accuracy=90
		maxPP=10
		introduced="Generation I"
	Supersonic
		elementType="Normal"
		category="Status"
		power=0
		accuracy=55
		maxPP=20
		introduced="Generation I"
	Surf
		elementType="Water"
		category="Special"
		power=95
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Swift
		elementType="Normal"
		category="Special"
		power=60
		accuracy=0
		maxPP=20
		introduced="Generation I"
	Swords_Dance
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=30
		introduced="Generation I"
	Tackle
		effectIcon="Hit"
		soundEffect='Blow1.ogg'
		desc="A full-body charge attack."
		longDesc="A physical attack in which the user charges and slams into the target with its whole body."

		elementType="Normal"
		category="Physical"
		power=50
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Tail_Whip
		effectIcon="Swoop"
		soundEffect='Wind1.ogg'
		effectsStatStages=list("defense"=-1)
		desc="Lowers the foe's DEFENSE."
		longDesc="The user wags its tail cutely, making opposing Pokmon less wary and lowering their Defense stat."

		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Take_Down
		elementType="Normal"
		category="Physical"
		power=90
		accuracy=85
		maxPP=20
		introduced="Generation I"
	Teleport
		elementType="Psychic"
		category="Status"
		power=0
		accuracy=0
		maxPP=20
		introduced="Generation I"
	Thrash
		elementType="Normal"
		category="Physical"
		power=120
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Thunder
		elementType="Electric"
		category="Special"
		power=120
		accuracy=70
		maxPP=10
		introduced="Generation I"
	Thunder_Wave
		elementType="Electric"
		category="Status"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Thunderbolt
		elementType="Electric"
		category="Special"
		power=95
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Thunderpunch
		elementType="Electric"
		category="Physical"
		power=75
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Thundershock
		effectIcon="Bolt"
		soundEffect='Thunder10.ogg'
		causesEffects=list("Paralysis"=10)
		desc="An attack that may cause paralysis."
		longDesc="A jolt of electricity is hurled at the target to inflict damage. It may also leave the target with paralysis."

		elementType="Electric"
		category="Special"
		power=40
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Toxic
		elementType="Poison"
		category="Status"
		power=0
		accuracy=90
		maxPP=10
		introduced="Generation I"
	Transform
		elementType="Normal"
		category="Status"
		power=0
		accuracy=0
		maxPP=10
		introduced="Generation I"
	Tri_Attack
		elementType="Normal"
		category="Special"
		power=80
		accuracy=100
		maxPP=10
		introduced="Generation I"
	Twineedle
		elementType="Bug"
		category="Physical"
		power=25
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Vicegrip
		elementType="Normal"
		category="Physical"
		power=55
		accuracy=100
		maxPP=30
		introduced="Generation I"
	Vine_Whip
		effectIcon="VineWhip"
		soundEffect='Wind1.ogg'
		desc="Whips the foe with slender vines."
		longDesc="The target is struck with slender, whiplike vines to inflict damage."

		elementType="Grass"
		category="Physical"
		power=35
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Water_Gun
		elementType="Water"
		category="Special"
		power=40
		accuracy=100
		maxPP=25
		introduced="Generation I"
	Waterfall
		elementType="Water"
		category="Physical"
		power=80
		accuracy=100
		maxPP=15
		introduced="Generation I"
	Whirlwind
		elementType="Normal"
		category="Status"
		power=0
		accuracy=100
		maxPP=20
		introduced="Generation I"
	Wing_Attack
		elementType="Flying"
		category="Physical"
		power=60
		accuracy=100
		maxPP=35
		introduced="Generation I"
	Withdraw
		elementType="Water"
		category="Status"
		power=0
		accuracy=0
		maxPP=40
		introduced="Generation I"
	Wrap
		elementType="Normal"
		category="Physical"
		power=15
		accuracy=90
		maxPP=20
		introduced="Generation I"