mob/proc/ClearItemHUD()
	src.itemDisplay.icon=null
	HideToolTip(src,"ItemDesc")

obj/NPCs
	icon='Characters.dmi'
	density=1
	bound_x=8
	bound_y=2
	bound_width=16
	bound_height=16
	var/list/shopInventory
	var/initialDir
	var/changesDir=1
	New()
		src.initialDir=src.dir
		return ..()
	Interact(var/mob/M)
		if(src.changesDir)	src.dir=get_dir(src,M)
		if(src.chatMsgs)
			for(var/v in src.chatMsgs)	ShowMsg(M,v)
		if(src.shopInventory)
			var/shopChoice=QuickChatChoice(M,list("Buy","Sell"),"Welcome!\nWhat can I do for you today?")
			ShopStart
			if(!M)	return
			if(shopChoice=="Buy")
				M.ShowGold()
				M.CustBG(10,7,17,17,"ShopBG")
				var/list/priceList=list()
				for(var/obj/Items/I in src.shopInventory)	priceList+="[PadText(I.price,4," ")]"
				var/list/listTexts=M.WriteList(priceList,"16,16:16",1)
				var/obj/Items/itemChosen=M.CreateHUDChoices(src.shopInventory+cancelObj,"10,16:16",1,10,1,1)
				if(!M)	return
				M.ClearBG("ShopBG")
				for(var/v in listTexts)	M.UpdateHUDText(v,null)
				if(istype(itemChosen,/obj/Items/CancelObj))	itemChosen=null
				if(istype(itemChosen,/obj/Items))
					var/buyAmt=1
					M.ClearItemHUD()
					if(istype(itemChosen,/obj/Items/Clothes) && M.icon_state==itemChosen.icon_state)
						ShowMsg(M,"You are already wearing this outfit.");goto AnythingElse
					if(!itemChosen.maxBuy)	buyAmt=M.GetNumber("How many [itemChosen.name]s would you like?")
					if(!buyAmt)	goto AnythingElse
					var/totalCost=itemChosen.price*buyAmt
					if(QuickChatChoice(M,list("Buy","Cancel"),"[buyAmt] [itemChosen.name]s?  Certainly.\nThat will be [FullNum(totalCost)] Gold.")!="Buy")	goto AnythingElse
					if(M.TakeGold(totalCost))
						M<<sound('Shop.ogg')
						itemChosen.BoughtBy(M,buyAmt)
						ShowMsg(M,"Here you go!\nThank you very much.")
					else	ShowMsg(M,"You don't have enough Gold.")
					AnythingElse
					ShowMsg(M,"Anything else today?")
					goto ShopStart
			if(shopChoice=="Sell")
				M.ShowGold()
				var/obj/Items/itemChosen=M.GetInventoryItem()
				if(!M)	return
				M.ClearBG("ShopBG")
				if(istype(itemChosen,/obj/Items/CancelObj))	itemChosen=null
				if(istype(itemChosen,/obj/Items))
					var/thisAmt=1
					M.ClearItemHUD()
					var/curAmt=text2num(itemChosen.suffix)
					thisAmt=M.GetNumber("How many [itemChosen.name]s would you like to sell?",curAmt)
					if(!thisAmt)	goto AnythingElse
					thisAmt=max(0,thisAmt)
					thisAmt=min(curAmt,thisAmt)
					var/totalCost=round(itemChosen.price*thisAmt/2)
					if(QuickChatChoice(M,list("Sell","Cancel"),"Selling [thisAmt] [itemChosen.name]s?  Certainly.\nI'll give you [FullNum(totalCost)] Gold for that.")!="Sell")	goto AnythingElse
					M.AddGold(totalCost)
					M<<sound('Shop.ogg')
					M.RemoveItem(itemChosen,thisAmt)
					ShowMsg(M,"Here you go!\nThank you very much.")
					AnythingElse
					ShowMsg(M,"Selling anything else today?")
					goto ShopStart
		if(M)
			M.HideGold()
			M.ClearItemHUD()
		src.dir=src.initialDir
		if(src.chatMsgs || src.shopInventory)	return 1
	Sign
		icon='Signs.dmi'
		icon_state="Sign"
		bound_x=8
		bound_width=16
		bound_height=24
		changesDir=0
	Wandering
		bound_y=1
		bound_x=8
		bound_width=16
		bound_height=16
		var/stepSizeMultiplier=1
		icon='Animals.dmi'
		icon_state="Cat"
		canCross=1
		canBeCrossed=1
		New()
			src.step_size=baseStepSize*src.stepSizeMultiplier
			src.loc=null
			return
			WalkRand(src,0.5)
			return ..()
	Chatty
		icon='Characters.dmi'
		icon_state="Soldier01"
		chatMsgs=list("Hello?")
	Storage_Crystal
		icon='Crystals.dmi'
		icon_state="Storage"
		Interact(var/mob/M)
			var/quickChoice=QuickChatChoice(M,list("Deposit","Withdraw"),"Monster Storage Crystal")
			if(!M)	return
			switch(quickChoice)
				if("Deposit")
					var/mob/Pets/P=input("Select a Monster to Deposit in Storage:","Storage Crystal") as null|anything in M.petsHeld
					if(!P || M.petsHeld.len<=1)	goto Return
					M.StorePet(P)
					M.SetActivePet()
				if("Withdraw")
					if(M.petsHeld.len>6)
						ShowMsg(M,"You cannot take more than 6 monsters with you.");goto Return
					var/mob/Pets/P=input("Select a Monster to Withdraw from Storage:","Storage Crystal") as null|anything in M.petStorage
					if(!P || M.petsHeld.len>=6)	goto Return
					M.petsHeld+=P
					M.petStorage-=P
					M.SetActivePet()
			Return
			return 1
	Nurse
		icon_state="Civilian20"
		Interact(var/mob/M)
			ShowMsg(M,"Hello, and welcome to the Monster Inn.")
			ShowMsg(M,"We restore your tired Monsters to full health.")
			if(QuickChatChoice(M,list("Rest","Cancel"),"Would you like to rest your Monsters?")!="Rest")	goto EndMsg
			ShowMsg(M,"Okay, I'll take your Monsters for a few seconds.")
			src.dir=turn(src.dir,180)
			if(M)
				M.isLoading=1
				M.ChangeMusic('014-Inn01.mid',0)
				sleep(40)
				if(M)
					M.isLoading=0
					M.RestorePets()
					M.ChangeMusic('034-Heaven01.mid')
			src.dir=initialDir
			ShowMsg(M,"Thank you for waiting.")
			ShowMsg(M,"We've restored your Monsters to full health.")
			EndMsg
			ShowMsg(M,"We hope to see you again!")
			return 1
	Shops
		icon_state="Trader01"
		ClothesShop
			icon_state="Civilian12"
			chatMsgs=list("Come one!  Come all!\nFor the finest looks in all the land!")
			shopInventory=list(new/obj/Items/Clothes/Fighter01,new/obj/Items/Clothes/Fighter02,new/obj/Items/Clothes/Fighter03,\
				new/obj/Items/Clothes/Fighter04,new/obj/Items/Clothes/Fighter05,new/obj/Items/Clothes/Fighter06,\
				new/obj/Items/Clothes/Fighter07,new/obj/Items/Clothes/Fighter08)
		Starter_Shop
			shopInventory=list(new/obj/Items/Catchers/Stones/Soul_Stone,new/obj/Items/Catchers/Stones/Great_Stone,new/obj/Items/Catchers/Stones/Ultra_Stone,\
				new/obj/Items/Catchers/Stones/Exp_Stone,new/obj/Items/Catchers/Stones/Heat_Stone,new/obj/Items/Catchers/Stones/Frost_Stone)