mob/proc
	AllPets()
		return src.petsHeld+src.petStorage
	StorePet(var/mob/Pets/P)
		if(!src.petStorage)	src.petStorage=list()
		src.petsHeld-=P
		src.petStorage+=P
	AddPet(var/mob/Pets/P)
		P.isWild=0
		P.ownerMob=src
		P.owner=src.key
		if(src.petsHeld.len<6)	src.petsHeld+=P
		else
			src.StorePet(P)
			ShowMsg(src,"[P] sent\nto Monster Storage.")
	SetActivePet(/**/)
		for(var/mob/Pets/P in src.petsHeld)	if(P.HP>0)
			if(src.activePet!=P)
				if(src.activePet)
					//walk(src.activePet,0)
					src.activePet.loc=null
				src.activePet=P
				src.activePet.SetBounds()
				src.activePet.step_size=src.step_size
				src.activePet.FollowOwner()
			break
	RestorePets()
		for(var/mob/Pets/P in src.petsHeld)
			for(var/effect in P.statusEffects)	P.RemoveEffect(effect)
			P.HP=P.maxHP;for(var/obj/Moves/PM in P.moveObjs)	PM.PP=PM.maxPP
		src.SetActivePet()

mob/Pets/SelectionReaction(var/mob/M)
	if(!M.inBattle)	return
	HideToolTip(M,"BattleStats")
	ShowToolTip(M,"BattleStats",2,8,6,10,"[src.name]\nLevel [src.level]\nHP [src.HP]/[src.maxHP]")

var/list/firstEvoPets=list()
proc/PopulateFirstEvos()
	for(var/v in typesof(/mob/Pets))
		var/mob/Pets/P=new v
		for(var/e in P.evolutionList)
			var/thisType="[P.parent_type]/[e]"
			if(!(thisType in firstEvoPets))	firstEvoPets+=thisType
			break
	for(var/v in firstEvoPets)
		firstEvoPets-=v
		firstEvoPets+=new v(1)

mob/Pets/proc
	SetCaptureInfo(var/capWith,var/capZone)
		src.captureInfo=list("Date","Level","Location","Caught With")
		src.captureInfo["Date"]=time2text(world.timeofday,"MMM DD YYYY")
		src.captureInfo["Level"]=src.level
		src.captureInfo["Location"]=capZone
		src.captureInfo["Caught With"]=capWith
	GetCaptureInfo(var/infoIndex)
		if(!src.captureInfo)	src.SetCaptureInfo()
		return src.captureInfo[infoIndex]
	FollowOwner(/**/)
		if(!src.ownerMob)	return
		src.PixelLocate(src.ownerMob,src.ownerMob.dir)
		src.step_y+=1;src.UpdateLayer()
		//walk_to(src,src.ownerMob,1)
	WildName()
		if(src.isWild)
			if(src.isShiny)	return "Bright [uppertext(src.name)]"
			return "Wild [uppertext(src.name)]"
		else	return "[src.name]"
	GetBattleName()
		var/battleName=src.name
		battleName=TrimText(battleName,"\\M")
		battleName=TrimText(battleName,"\\F")
		if(src.isWild)	battleName=uppertext(battleName)
		return battleName
	EnterBattle()
		src.SetBattleIcons()
		var/mob/Pets/thisOpponent=src.petOpponent
		if(thisOpponent && thisOpponent.ownerMob && thisOpponent.ownerMob.client)	spawn(-1)
			var/icon/I=new(src.battleFront.icon)
			var/xPixelOffset=round((I.Width()-96)/2),xTileOffset=0
			while(xPixelOffset>=32)	{xTileOffset+=1;xPixelOffset-=32}
			src.battleFront.screen_loc="[15-xTileOffset]:[-xPixelOffset],9:[src.battleFront.screen_y]"
			thisOpponent.ownerMob.client.screen+=src.battleFront
			src.battleFront.ScreenMove(WEST,11)
		if(src.ownerMob && src.ownerMob.client)
			src.battleBack.dir=NORTH
			var/icon/I=new(src.battleBack.icon)
			var/xPixelOffset=round((I.Width()-96)/2),xTileOffset=0
			while(xPixelOffset>=32)	{xTileOffset+=1;xPixelOffset-=32}
			src.battleBack.screen_loc="[15-xTileOffset]:[-xPixelOffset],8:[src.battleBack.screen_y]"
			src.ownerMob.client.screen+=src.battleBack
			src.battleBack.ScreenMove(WEST,3)
		else	sleep(3)
	ExitBattle(/**/)
		var/mob/Pets/thisOpponent=src.petOpponent
		if(thisOpponent && thisOpponent.ownerMob && thisOpponent.ownerMob.client)	spawn(-1)
			src.battleFront.ScreenMove(EAST,11)
			thisOpponent.ownerMob.client.screen-=src.battleFront
		if(src.ownerMob && src.ownerMob.client)
			src.battleBack.ScreenMove(EAST,3)
			src.ownerMob.client.screen-=src.battleBack
		else	sleep(3)
	GiveLevelMoves()
		for(var/v in src.levelMoves)
			var/splitText=Split(v,"@")
			var/moveName=splitText[1]
			var/moveLevel=text2num(splitText[2])
			if(src.level<moveLevel)	break
			for(var/obj/Moves/M in src.moveObjs)
				if(M.name==moveName)	goto AlreadyHasMove
			if(src.moveObjs.len>=4)
				if(prob(75))	src.moveObjs-=pick(src.moveObjs)
				else	goto MovesFull
			var/moveType="/obj/Moves/[moveName]"
			while(findtext(moveType," "))	moveType=FindAndReplace(moveType," ","_")
			if(text2path(moveType) in typesof(/obj/Moves))	src.moveObjs+=new moveType
			AlreadyHasMove
			MovesFull
	SetLevel(var/newLevel)
		src.level=newLevel
		src.CalculateExp()
		src.CalculateStats()
		src.HP=src.maxHP
		src.moveObjs=list()
		src.GiveLevelMoves()
	BattleSoundEffect(var/soundEffect)
		src.ownerMob<<sound(soundEffect)
		if(src.petOpponent)	src.petOpponent.ownerMob<<sound(soundEffect)
	BattleScreenEffect(var/effectIcon)
		if(src.ownerMob)	src.ownerMob.ShowScreenEffect(src.battleBack,effectIcon,src.battleBack.screen_y)
		if(src.petOpponent.ownerMob)	src.petOpponent.ownerMob.ShowScreenEffect(src.battleFront,effectIcon,src.battleFront.screen_y)