mob/var
	list/TempStats	//Reset for Current Goals
	list/SessionStats	//Tracks Play Session
	list/TotalStats	//All-Time Tracked

mob/proc
	GetTrackedStat(var/Stat,var/list/List)
		if(Stat in List)	return List[Stat]
	ResetTrackedStats(var/list/Tracks)
		for(var/v in Tracks)	if(v in src.TempStats)	src.TempStats[v]=null
	TrackStat(var/Stat,var/Value,var/TrackingType="Total",var/Listing="Once")
		if(!src.TempStats)	src.TempStats=list()
		if(!src.SessionStats)	src.SessionStats=list()
		if(!src.TotalStats)	src.TotalStats=list()
		for(var/v in list("TempStats","SessionStats","TotalStats"))
			var/list/L=src.vars[v]
			if(!(Stat in L))	L+=Stat
			if(TrackingType=="List")
				if(!L[Stat])	L[Stat]=list()
				if(Listing=="Once")	if(!(Value in L[Stat]))	L[Stat]+=Value
				else	L[Stat]+=Value
			else
				if(isnum(Value))
					if(TrackingType=="Highest")	if(L[Stat]==null || L[Stat]<Value)	L[Stat]=Value
					else	if(TrackingType=="Lowest")	if(L[Stat]==null || L[Stat]>Value)	L[Stat]=Value
					else	L[Stat]+=Value
				else	L[Stat]=Value

proc/islist(var/L)
	return istype(L,/list)

mob/verb/Sense()
	set src in world
	set category=null
	var/HTML="<title>[src]'s Stat Tracking</title><body bgcolor=black><center>"
	var/Fmt="<font color=[rgb(255,128,0)]>"
	var/TdR="<td align=right>"
	var/TdC="<td><center>"
	HTML+="<table bgcolor=[rgb(0,0,64)] border=1 width=100%>"
	HTML+="<tr>[TdC][Fmt]<b>Stat[TdC][Fmt]<b>Active[TdC][Fmt]<b>Session[TdC][Fmt]<b>Total"
	for(var/v in src.TotalStats)
		var/list/L=list("ActiveStat","SessionStat","TotalStat")
		L["ActiveStat"]=src.GetTrackedStat(v,src.TempStats)
		L["SessionStat"]=src.GetTrackedStat(v,src.SessionStats)
		L["TotalStat"]=src.GetTrackedStat(v,src.TotalStats)
		for(var/s in L)
			if(isnum(L[s]))	L[s]=FullNum(L[s])
			else	if(L[s]==null)	L[s]="-"
			else	if(islist(L[s]))	{var/list/LenList=L[s];L[s]="[LenList.len]"}
		HTML+="<tr><td>[Fmt][v]<b>:[TdR][Fmt][L["ActiveStat"]][TdR][Fmt][L["SessionStat"]][TdR][Fmt][L["TotalStat"]]"
	HTML+="</table>"
	usr<<browse(HTML,"window=PlayerStats")