mob/Pets/var/list/statusEffects
obj/StatusEffects
	var/damageMult
	var/healMult
	var/gotEffect
	var/hasEffect
	var/lostEffect
	var/effectIcon
	var/soundEffect
	var/minDuration=0
	var/maxDuration=0
	Paralysis
		gotEffect="was Paralyzed"
		hasEffect="is Paralyzed"
		effectIcon="Paralysis"
		soundEffect='Paralyze3.ogg'
	Poison
		damageMult=1/8
		gotEffect="was Poisoned"
		hasEffect="is Poisoned"
		effectIcon="Poison"
		soundEffect='Poison.ogg'
	Leech_Seed
		damageMult=1/8
		healMult=1
		gotEffect="was Seeded"
		hasEffect="is Seeded"
		effectIcon="LeechSeed"
		soundEffect='Heal4.ogg'
	Burn
		damageMult=1/8
		gotEffect="was Burned"
		hasEffect="is Burning"
		effectIcon="Fire"
		soundEffect='Fire1.ogg'
	Flinch
		gotEffect="Flinches"
		hasEffect="Flinched"
		effectIcon="Fear"
		soundEffect='Monster2.ogg'
	Sleep
		gotEffect="fell Asleep"
		hasEffect="is Asleep"
		lostEffect="woke up"
		soundEffect='Sleep.ogg'
		minDuration=2
		maxDuration=4

var/list/statusEffectObjs=list()
proc/PopulateStatusEffects()
	for(var/v in typesof(/obj/StatusEffects)-/obj/StatusEffects)
		var/obj/StatusEffects/E=new v
		statusEffectObjs+=E.name
		statusEffectObjs[E.name]=E

mob/Pets/proc
	HasEffect(var/effect)
		if(effect in src.statusEffects)	return 1
	AddEffect(var/effect)
		var/obj/StatusEffects/E=statusEffectObjs[effect]
		if(src.HasEffect(effect))
			ShowBattleMsg(src,"[src.WildName()] already\n[E.gotEffect]!")
			return
		if(!src.statusEffects)	src.statusEffects=list()
		src.statusEffects+=effect
		src.statusEffects[effect]=rand(E.minDuration,E.maxDuration)
		src.BattleScreenEffect(E.effectIcon)
		if(E.soundEffect)	src.BattleSoundEffect(E.soundEffect)
		ShowBattleMsg(src,"[src.WildName()] [E.gotEffect]!")
	RemoveEffect(var/effect)
		src.statusEffects-=effect
	StEfTurnDuration()
		for(var/v in src.statusEffects)	if(src.statusEffects[v])
			src.statusEffects[v]-=1
			if(src.statusEffects[v]<=0)
				var/obj/StatusEffects/thisEffect=statusEffectObjs[v]
				src.RemoveEffect(thisEffect.name)
				ShowBattleMsg(src,"[src.WildName()] [thisEffect.lostEffect]!")
	StEfTurnLoss()
		var/obj/StatusEffects/thisEffect
		if(rand(1,100)<=25 && src.HasEffect("Paralysis"))	thisEffect=statusEffectObjs["Paralysis"]
		if(src.HasEffect("Sleep"))	thisEffect=statusEffectObjs["Sleep"]
		if(src.HasEffect("Flinch"))	thisEffect=statusEffectObjs["Flinch"]
		if(thisEffect)
			if(thisEffect.name=="Flinch")	src.RemoveEffect("Flinch")
			src.BattleScreenEffect(thisEffect.effectIcon)
			if(thisEffect.soundEffect)	src.BattleSoundEffect(thisEffect.soundEffect)
			ShowBattleMsg(src,"[src.WildName()] [thisEffect.hasEffect]\nand cannot move!")
		return thisEffect
	StEfDamage()
		for(var/v in src.statusEffects)
			var/obj/StatusEffects/E=statusEffectObjs[v]
			if(!E.damageMult)	continue
			ShowBattleMsg(src,"[src.WildName()] [E.hasEffect]\nand took damage!")
			src.BattleScreenEffect(E.effectIcon)
			if(E.soundEffect)	src.BattleSoundEffect(E.soundEffect)
			var/thisDamage=round(src.maxHP*E.damageMult)
			src.TakeDamage(thisDamage)
			if(E.healMult && src.petOpponent)	src.petOpponent.AddHP(round(thisDamage*E.healMult))
	GetStatusEffectCatchRate()
		var/statusBonus=1
		if(src.HasEffect("Sleep") || src.HasEffect("Freeze"))	statusBonus=2
		else	if(src.HasEffect("Paralysis") || src.HasEffect("Poison") || src.HasEffect("Burn"))	statusBonus=1.5
		return statusBonus