obj/Doorway
	layer=myEFFECTS_LAYER+1
	var/newX,newY,newZ,newDir,newMusicID
	Cross(var/mob/M)
		if(ismob(M) && M.client)
			for(var/obj/D in oview(1,src))	if(D.name=="Doors")
				flick("[D.icon_state]Open",D)
				view(M)<<sound('Open1.ogg')
			M.LoadingFade()
			if(M)
				M.ExitCave()
				if(newMusicID)	M.ZoneMusic(musicArray[newMusicID])
				M.PixelLocate(locate(src.newX,src.newY,src.newZ),newDir)
		return ..()
obj/CaveEntrance
	var/battleBG="Cave"
	var/caveType="Cave"
	var/tagTo
	//Cave Types:	Cave, Mine
	var/enemyTypes=list("/mob/Pets/RPGMaker/Ratix","/mob/Pets/RPGMaker/Zombat","/mob/Pets/RPGMaker/Cockatrice")
	layer=myEFFECTS_LAYER+1
	Cross(var/mob/M)
		if(ismob(M) && M.client)
			M.isLoading=1
			M.FadeEffect("FadeOut",0)
			M.caveLoc="x=[src.x]&y=[src.y]&z=[src.z]"
			M.battleBG=src.battleBG
			M.caveLevel=0
			for(var/mob/Pets/P in M.petsHeld)	M.caveLevel+=P.level
			M.caveLevel=round(M.caveLevel/M.petsHeld.len)
			M.caveObj=src
			spawn(5)	if(M)
				var/turf/caveEntrance=GenerateCave(M,src.caveType)
				M.PixelLocate(get_step(caveEntrance,SOUTH),SOUTH)
				M.ZoneMusic('037-Dungeon03.mid')
				M.FadeEffect("FadeIn",5)
		return ..()

mob/proc/ExitCave()
	if(src.caveObj)
		src.caveLoc=null
		src.caveObj=null
		src.caveLevel=null
		cavesInUse["[src.z]"]-=src

area/Shadows
	layer=TURF_LAYER+1
	icon='Shadows.dmi'
	mouse_opacity=0

turf
	icon='Turfs.dmi'
	Grass
		icon_state="Grass1"
		New()
			src.icon_state="Grass[rand(1,4)]"
			if(prob(7.5))	spawn(1)	if(!src.contents.len)
				src.icon_state="Grass[rand(5,13)]"
			return ..()
	Supplemental
		Density
			layer=10
			density=1
		Black
			density=1
			opacity=1
			icon_state="Black"
			layer=myEFFECTS_LAYER

mob/proc/StartRandomBattle()
	if(!src.encounterRate)	return
	var/possiblePets=firstEvoPets
	if(src.caveObj)	possiblePets=src.caveObj.enemyTypes
	var/mob/Pets/newPet=text2path(pick(possiblePets))
	newPet=new newPet(1)
	if(newPet.isShiny)	src.GiveMedal("Bright Sight")
	if(src.caveLevel)	newPet.SetLevel(src.caveLevel+rand(-2,0))
	src.StartBattleAgainst(newPet)

turf/Entered(var/mob/M)
	if(ismob(M) && M.client && M.caveObj)
		M.stepsUntilBattle-=1
		if(M.stepsUntilBattle<=0)	M.StartRandomBattle()

obj/BattleBushes
	Crossed(var/mob/M)
		if(ismob(M) && M.client)
			M.stepsUntilBattle-=1
			if(M.stepsUntilBattle<=0)	M.StartRandomBattle()
	TallGrass
		icon='Woods01.dmi'
		icon_state="TallGrass"
		New()
			if(!(src.y%2))	src.step_x+=4
			else	src.step_x-=4
			src.step_y+=8
			return ..()

turf
	Beaches
		Ocean01
			icon='Ocean01.dmi'
			Water
				density=1
				icon_state="TBLR"
			Sand
				icon_state="Sand"
	Shop01
		icon='Shop01.dmi'
		Walls
			density=1
			icon_state="WallBL"
		StoneWalls
			density=1
			icon_state="StoneWallBL"
		Floor
			icon_state="WoodenTiles"
	Castle01
		icon='Castle01.dmi'
		Wall
			density=1
			icon_state="Wall"
		MossyWall
			density=1
			icon_state="MossyWall"
		Pillar
			density=1
			icon_state="PillarB"

obj
	Castle01
		bound_height=32
		icon='Castle01.dmi'
		Flowers
			bound_y=4
			layer=TURF_LAYER
			icon_state="Flowers1"
	RpgPort
		bound_height=64
		icon='Port.dmi'
		Wall
			density=1
			icon_state="Wall"
		MossyWall
			density=1
			icon_state="MossyWall"
		GrassPatch
			layer=TURF_LAYER
			icon_state="GrassPatch1"
		Roofs
			density=1
			bound_width=64
			bound_height=128
			RoofL
				icon='PortRoofL.png'
			RoofM
				bound_height=64
				icon='PortRoofM.png'
			RoofR
				icon='PortRoofR.png'